
VERS	EQU	01	;Version Number	(XX.)
MODF	EQU	52	;Modification	(.xx)

DAY	EQU	19
MONTH	EQU	05
YEAR	EQU	1998

DIRPAGE	EQU	0
FATPAGE	EQU	1
TXTPAGE	EQU	2
DIR	EQU	#C000
FAT	EQU	#C000

ORG_	ORG	#8000
ROM__
	DISP   #0000
A0000	JP	LEAVE		;CLOSE TASK
	DEFB	#FF,#FF,#FF,#FF,#FF
A0008	PUSH	AF		;INT BIOS
	LD	A,#00
	OUT	(#7C),A
	POP	AF
	RET
	RET
A0010	JP	RST_10		;INT DOS
	DEFB	#FF,#FF,#FF,#FF,#FF
A0018	JP	INTDISK		;INT DISK
	DEFB	#FF,#FF,#FF,#FF,#FF
A0020	JP	RST_20		;
	DEFB	#FF,#FF,#FF,#FF,#FF
A0028	JP	RST_28		;
	DEFB	#FF,#FF,#FF,#FF,#FF
A0030	JP	INTMOUS		;INT MOUSE
	DEFB	#FF,#FF,#FF,#FF,#FF
A0038	JP	RST_38		;INTERRUPT

;WARNING! DON'T	CHANGE LENGHT OF MASK INTERUPT!
;FOR CORRECTED WORKING "Non-Mask Interupt"

RST_38	;MAIN INTERUPT
INT_	PUSH	AF
	EX	AF,AF'
	PUSH	AF
	PUSH	BC
	PUSH	DE
	PUSH	HL
	EXX
	PUSH	BC
	PUSH	DE
	PUSH	HL
	PUSH	IX
	PUSH	IY
	CALL	KEYSCAN
	LD	C,#80
	RST	#30
	POP	IY
	POP	IX
	POP	HL
	POP	DE
	POP	BC
	EXX
	POP	HL
	POP	DE
	POP	BC
	POP	AF
	EX	AF,AF'
	POP	AF
	EI
	RETI

RST_20
RST_28
	LD	A,1
	SCF
	RET

NMI	RETN
	NOP
	NOP
	NOP
A0066	JP	NMI

;JP_NN	 PUSH	 HL
;	 LD	 HL,(NNNN)
;	 EX	 (SP),HL
;	 RET

;RST_00	 EX	 (SP),HL
;	 PUSH	 AF
;	 LD	 L,(HL)
;	 LD	 H,ADRST00/256
;	 LD	 A,(HL)
;	 INC	 H
;	 LD	 H,(HL)
;	 LD	 L,A
;	 POP	 AF
;	 EX	 (SP),HL
;	 RET

;RST_08	 PUSH	 HL
;	 LD	 L,C
;	 LD	 H,ADRST00/256
;	 LD	 C,(HL)
;	 INC	 H
;	 LD	 H,(HL)
;	 LD	 L,C
;	 EX	 (SP),HL
;	 RET

RST_10	PUSH	HL
	LD	L,C
	LD	H,ADRST10/256
	LD	C,(HL)
	INC	H
	LD	H,(HL)
	LD	L,C
	EX	(SP),HL
	RET

TEXT0	EQU	$
TEXT1	EQU	$+#20
VER	XOR	A
	LD	(LDRIVE),A
	CALL	KINIT
	LD	C,0
	RST	#30
	LD	A,(VMODE)
	LD	C,#81
	RST	#30
	CALL	INITDVC
	LD	DE,VERSION
	LD	HL,ADRST10
	LD	(HL),E
	INC	H
	LD	(HL),D
	LD	BC,#03C2
	RST	#08
	LD	HL,BANKTBL
	LD	C,A
	LD	B,#FF
VERINIT	INC	B
	PUSH	BC
	PUSH	HL
	LD	A,C
	LD	C,#C4
	RST	#08
	POP	HL
	POP	BC
	LD	(HL),A
	INC	HL
	JR	NC,VERINIT
	JP	VERSION

	DEFS	$/256+1*256-$,0

;	ENT
;	ORG	$/256+1*256
;	DISP   $-#8000

MEMTAB	DEFS	256,0

ADRST10	DEFS	512,0

; Area for boot	sector [512Bytes]
BOOT	DEFB	#00,#00,#00 ; +00 JMP
ID_NAME	DEFB	"DOS_1.52"  ; +03 DOS NAME

; Block	Parameters BIOS

B_P_S	DEFW	#0200	    ; +0B BYTE PER SECTOR
S_P_C	DEFB	2	    ; +0D SECTORS PER CLUSTER
RESERVE	DEFW	1	    ; +0E RESERVE SECTORS
FAT_NUM	DEFB	2	    ; +10 AMOUNT FATS
F_P_DIR	DEFW	112	    ; +11 FILES	IN DIRECTORY
S_P_D	DEFW	1440	    ; +13 ALL SECTORS ON DISK
ID_FORM	DEFB	#F0	    ; +15 ID FORMAT
S_P_F	DEFW	2	    ; +16 SIZE FAT IN SECTORS
S_P_T	DEFW	9	    ; +18 SECTOR PER TRACK
HEADS	DEFW	2	    ; +1A AMOUNT SIDES
HIDDEN	DEFW	0	    ; +1C HIDDEN SECTORS

	DEFS	24,0

ID_FAT	DEFB	"FAT12"	    ; +36 FAT ID

	DEFS	453,0
; end boot sector

;AT_	DEFS	3*512,0

BUFFER
SECBUF	DEFB	".	    ",#10
	DEFW	0,0,0,0,0
	DEFW	#0000
	DEFW	#0000
	DEFW	#0000
	DEFW	#0000,0000
	DEFB	"..	    ",#10
	DEFW	0,0,0,0,0
	DEFW	#0000
	DEFW	#0000
	DEFW	#0000
	DEFW	#0000,0000
	DEFS	512-64,0

;[INCLUDE]
;KEYBOARD BUFFER
	INCLUDE	"KEYINTER
	INCLUDE	"VIDEO
	INCLUDE	"FAT_X
	INCLUDE	"DOS_X
	INCLUDE	"DOS_FM
	INCLUDE	"DOS5
	INCLUDE	"EXECUTE
	INCLUDE	"INTMOUSE

DTA	DEFB	"	 "
	DEFB	"   "
	DEFB	#20
	DEFW	0,0,0,0,0
	DEFW	0
	DEFW	0
CLUSTER	DEFW	0
SIZE	DEFW	0,0
ASCIIZ	DEFB	"FILENAME.EXT",#00

	INCLUDE	"DISK_X
	INCLUDE	"IDE_DRV0
	INCLUDE	"FDD_DRV0
	INCLUDE	"RAM_DRV0

;FUNCTION ADDRESS ARRAY
;--------------------------------------------------------------
	ENT
ENDCODE
	ORG	#8000+ADRST10

;FN 0  00h
	DEFB	VER},CHNDISK},CURRDSK},DISKINF},NOPS},NOPS},NOPS},NOPS}
;FN 8  08h
	DEFB	NOPS},BOOTDSK},CREATE},CREAT_N},NOPS},NOPS},DELETE},NOPS}
;FN 16 10h
	DEFB	RENAME},OPEN},CLOSE},READ},WRITE},MOVE_FP},ATTRIB},GET_D_T}
;FN 24 18h
	DEFB	PUT_D_T},F_FIRST},F_NEXT},MKDIR},RMDIR},CHDIR},CURRDIR},NOPS}
;FN 32 20h
	DEFB	NOPS},SYSTIME},SETTIME},NOPS},NOPS},NOPS},NOPS},NOPS}
;FN 40 28h
	DEFB	NOPS},NOPS},NOPS},NOPS},NOPS},NOPS},NOPS},NOPS}
;FN 48 30h
	DEFB	WAITKEY},SCANKEY},ECHOKEY},CTRLKEY},NOPS},K_CLEAR},K_SETUP},TESTKEY}
;FN 56 38h
	DEFB	SETWIN},SETWIN1},SETWIN2},SETWIN3},FREEMEM},GETMEM},RETMEM},SETMEM}
;FN 64 40h
	DEFB	EXEC},LEAVE},WAIT},GSWITCH},DOSNAME},NOPS},NOPS},NOPS}
;FN 72 48h
	DEFB	NOPS},NOPS},NOPS},NOPS},NOPS},NOPS},NOPS},NOPS}
;FN 80 50h
	DEFB	SETVMOD},GETVMOD},LOCATE},CURSOR},SELPAGE},SCROLL},CLEAR},RDCHAR}
;FN 88 58h
	DEFB	WRCHAR},WINCOPY},WINREST},PUTCHAR},PCHARS},NOPS},NOPS},PRINT}
;FN 96 60h
	DEFB	NOPS},NOPS},NOPS},NOPS},NOPS},NOPS},NOPS},NOPS}

	DEFS	#88,0
	DEFB	NOPS},NOPS},NOPS},NOPS},NOPS},NOPS},NOPS},NOPS}
	DEFB	NOPS},NOPS},NOPS},NOPS},NOPS},NOPS},NOPS},NOPS}

	DEFB	VER{,CHNDISK{,CURRDSK{,DISKINF{,NOPS{,NOPS{,NOPS{,NOPS{
	DEFB	NOPS{,BOOTDSK{,CREATE{,CREAT_N{,NOPS{,NOPS{,DELETE{,NOPS{
	DEFB	RENAME{,OPEN{,CLOSE{,READ{,WRITE{,MOVE_FP{,ATTRIB{,GET_D_T{
	DEFB	PUT_D_T{,F_FIRST{,F_NEXT{,MKDIR{,RMDIR{,CHDIR{,CURRDIR{,NOPS{
	DEFB	NOPS{,SYSTIME{,SETTIME{,NOPS{,NOPS{,NOPS{,NOPS{,NOPS{
	DEFB	NOPS{,NOPS{,NOPS{,NOPS{,NOPS{,NOPS{,NOPS{,NOPS{
	DEFB	WAITKEY{,SCANKEY{,ECHOKEY{,CTRLKEY{,NOPS{,K_CLEAR{,K_SETUP{,TESTKEY{
	DEFB	SETWIN{,SETWIN1{,SETWIN2{,SETWIN3{,FREEMEM{,GETMEM{,RETMEM{,SETMEM{
	DEFB	EXEC{,LEAVE{,WAIT{,GSWITCH{,DOSNAME{,NOPS{,NOPS{,NOPS{
	DEFB	NOPS{,NOPS{,NOPS{,NOPS{,NOPS{,NOPS{,NOPS{,NOPS{
	DEFB	SETVMOD{,GETVMOD{,LOCATE{,CURSOR{,SELPAGE{,SCROLL{,CLEAR{,RDCHAR{
	DEFB	WRCHAR{,WINCOPY{,WINREST{,PUTCHAR{,PCHARS{,NOPS{,NOPS{,PRINT{
	DEFB	NOPS{,NOPS{,NOPS{,NOPS{,NOPS{,NOPS{,NOPS{,NOPS{
	DEFS	#88,0
	DEFB	NOPS{,NOPS{,NOPS{,NOPS{,NOPS{,NOPS{,NOPS{,NOPS{
	DEFB	NOPS{,NOPS{,NOPS{,NOPS{,NOPS{,NOPS{,NOPS{,NOPS{

	ORG	ENDCODE
	DEFB	0
	ORG	ORG_

