#include "allvars.ash"
#include "ddef.asm"

HD_DRV::
; ᠭ ⮢ ஫
hd_dat   equ     0fh            ;  
hd_err   equ     2fh            ;  訡
hd_seccnt equ    4fh            ;  稪 ᥪ஢
hd_sect  equ     6fh            ;  ᥪ
hd_cyllo equ     8fh            ; .   樫
hd_cylhi equ     0afh           ; .   樫
hd_head  equ     0cfh           ;  
hd_comm  equ     0efh           ;  
; ᪮ HDD  16 ࠧ來 設   8-ࠧ來  
; /⥭ c訩  饫  ᯥ.  ( 010F)

; ⠡  ࠩ
        DW      HD_RES          ;  HD
        DW      HD_SEEK         ; 樮஢ HD
        DW      HD_FRM          ; ଠ஢ HD
        DW      HD_REC          ; ४஢ HD
        DW      HD_RD           ; ⥭ ᥪ
        DW      HD_NOP
        DW      HD_WR           ;  ᥪ

HD_tst: bit     6,(IY+DDTYP)    ; HDD 㦥 ?
        ret     nz                
        bit     7,(IY+DDTYP)    ;  ᪠
        jr      nz,_1err
        ld      bc,hd_comm
        in      a,(c)           ; ஢塞 祭  諥?
        inc     a
        jr      z,_1err         ; !
        ld      d,0
        call    HD_wt1
        or      a
        jr      nz,_1err
        ld      bc,hd_cylhi     ; ஢塞 ॣ  樫
        ld      a,55h
        out     (c),a
        cpl
        ld      c,hd_cyllo
        out     (c),a
        ld      c,hd_cylhi
        in      a,(c)
        cp      55h
        jr      nz,_1err
        ld      c,hd_cyllo
        in      a,(c)
        cp      0AAh
        jr      nz,_1err
        set     6,(IY+DDTYP)    ; ⠭ ਧ 
; ணࠬ   樫  ॣ HDD
hd_scl: ld      hl,(RQCYL)      ;  樫
        ld      bc,hd_cyllo
        out     (c),l
        ld      c,hd_cylhi
        out     (c),h
        ret

_1err:  set     7,(IY+DDTYP)    ;  ਧ ⢨⥫쭮
        pop     af              ; SP=SP+2
nr_err: ld      a,_NRDY         ; HDD  ⮢ !
        or      a
        ret

HD_RES:
HD_REC: call    HD_tst
        ld      bc,hd_comm
        ld      a,10h
        out     (c),a           ; 뢠 
HD_wait::ld     d,64
hd_wt1: ld      bc,hd_comm
        ld      hl,0
hd_w_lp:in      e,(c)
        bit     7,e
        jr      z,hd_w_dn       ;  ᨣ ⮢
        dec     hl
        ld      a,l
        or      h
        jr      nz,hd_w_lp
        dec     d
        jr      nz,hd_w_lp
        jr      nr_err          ;  ⮢ ன⢠

hd_w_dn:bit     0,e
        jr      nz,is_hd_err    ; ⠭  訡
;        and     50h
;        sub     50h
;        jr      nz,hd_w_lp
HD_NOP: xor     a
        ret

; ࠡ⪠ 訡
is_hd_err:
        ld      bc,hd_err
        in      b,(c)
        bit     0,b
        ld      a,_NO$ADDR$MARK
        ret     nz
        bit     2,b
        jr      nz,hd_err_ab
        bit     4,b
        ld      a,_NO$DATA
        ret     nz
        bit     6,b
        jr      z,hd_sh1
        bit     2,e
        ld      a,_CRC$ERR
        ret     z
        xor     a
        ret
hd_sh1: bit     7,b
        ld      a,_FATAL$ERROR
        ret     nz
        ld      a,_HRDERR
        ret
hd_err_ab:
        bit     6,e
        ld      a,_NRDY
        ret     nz
        bit     5,e
        ld      a,_WR$PROT
        ret     nz
        bit     4,e
        ld      a,_IOERR
        ret     nz
        ld      a,_COMERR
        ret

; 樮஢  ࠭ 樫
HD_SEEK:call    HD_tst
        ld      hl,(RQCYL)
        ld      a,h
        or      l
        jr      z,HD_REC        ; ᫨ 㫥 - 믮塞 ४஢
        call    hd_scl          ; ⠭  樫
        ld      c,hd_comm
        ld      a,70h
        out     (c),a           ;  樮஢
        jr      HD_wait

; ⮢  /⥭
hd_set_rw:
        ld      a,(RQHEAD)      ;  
        or      0a0h
        ld      bc,hd_head
        out     (c),a
        ld      a,(RQSECT)      ;  ᥪ
        inc     a               ; (稭  1)
        ld      c,hd_sect
        out     (c),a
        ld      a,d
        ld      c,hd_seccnt
        out     (c),a           ; 稪 ᥪ஢ ( ⥭/ ᥣ 1
                                ;  ଠ஢ - ⢮ ᥪ஢ 
                                ; 樫)
        call    hd_scl          ; ⠭  樫
        ld      c,hd_comm
        ret

; ⥭ ᥪ
HD_RD:  call    HD_tst          ; ஢ઠ  HDD (᫨ )
        ld      d,1             ; 稪 ᥪ஢
        call    hd_set_rw       ; ⮢  ⥭
        ld      a,20h
        out     (c),a           ;  ⥭
        call    HD_wait         ;  ⮢ HDD
        or      a
        ret     nz
        ld      hl,(DCBUF)      ;   ⥭
        ld      bc,hd_dat       ;  
        inir                    ; ⥭ 1- 256 
        inir                    ; ⥭ 2-x 256 
        ld      bc,hd_comm
        in      a,(c)
        and     8
        ret     z
        ld      a,_OVERRUN
        ret

;⮢   (ଠ஢)
hd_setwr:
        call    hd_set_rw
        ld      a,30h           ;  
        out     (c),a
;  ᨣ ⮢   訡
hd_w_w: in      e,(c)
        bit     0,e
        jp      nz,is_hd_err    ; 訡
        bit     3,e
        jr      z,hd_w_w        ;    ⮢
        ld      bc,hd_dat+256
        ret

;  ᥪ
HD_WR:  call    HD_tst
        ld      d,1
        call    hd_setwr        ; ⮢  
        ld      hl,(DCBUF)      ;  
        dec     d               ; D=0
        inc     hl

hd_wlp:
        ld      a,(hl)          ; . 
        out     (c),a           ; 뢮 襣 
        dec     b               ;  . 
        dec     hl
        ld      a,(hl)
        out     (c),a           ; 뢮 襣 
        inc     b
        inc     hl
        inc     hl
        inc     hl

        push    bc
        ld      bc,hd_comm
        in      a,(c)
        pop     bc

        dec     d
        jr      nz,hd_wlp       ; த    ᠭ 256 ᫮
;   ᨣ WIRQ
hd_wwait:
        ld      bc,tlrd
hd_wlpd:in      a,(c)
        and     40h
        jr      z,hd_wlpd
; ᨣ WIRQ  -  ᠭ
        jp      HD_wait

; ଠ஢ 樫
; P.S. ଠ஢ -    ஦  ⮬ 㪠
;  RQBLN (筮  P/M  祭 0e5h),   㦭  ⪨
; ४.

HD_FRM: call    HD_SEEK         ;
        or      a
        ret     nz
        ld      d,(IY+DSECTT)   ; ⢮ ᥪ஢  ଠ஢
        call    hd_setwr
hd_f2:  ld      a,(RQBLN)       ;  ⥫
        out     (c),a           ; 뢠  饫 訩 
        dec     b
        ld      e,b
hd_f1:  push    bc
        ld      bc,hd_comm
        in      b,(c)
        pop     bc
        out     (c),a           ; 뢠 訩  (訩 饫)
        dec     e
        jr      nz,hd_f1

        ld      bc,tlrd
hd_f3:  in      a,(c)           ;  ᨣ WIRQ
        and     40h
        jr      z,hd_f3

        ld      bc,hd_comm
        in      e,(c)
        bit     0,e
        jp      nz,is_hd_err    ; 㦥 訡
        bit     3,e
        jp      z,HD_wait       ; 稪 ᥪ஢ 㫨
        ld      bc,hd_dat+256   ;  . 
        jr      hd_f2           ; த (᫥騩 ᥪ)

        end
