
	ORG	25000
;sprinter.lpr -	for epson compatible printers
LPT_A	EQU	#1B
LPT_B	EQU	#1C

R000	EQU	$-1
	DEFW	L004	;Initialization	printer
R001	EQU	$-1
	DEFW	R004	;Print char
R002	EQU	$-1
	DEFW	L004	;Reserved
R003	EQU	$-1
L000	DEFW	L001	;Print code
FLAG	DEFB	#03	;Flags
	DEFW	#0000
	DEFW	#0000
	DEFB	#01
	DEFW	#0000

R004	LD	HL,FLAG
	CP	#0D
	JR	NZ,R006
	BIT	0,(HL)
	JR	Z,R006
R005	CALL	R006
	RET	C
	LD	A,#0A
R006	LD	HL,(L000)
	JP	(HL)
L001	LD	E,A
L002	EI 
	LD	C,#09
	RST	#10
	JR	Z,L003
	LD	C,#07
	RST	#10
	CP	#10
	JR	Z,L005
	CP	#16
	JR	Z,L005
;Send symbol
L003	DI 
	XOR	A
	OUT	(LPT_A),A
	LD	A,#10
	OUT	(LPT_A),A
	XOR	A
	OUT	(LPT_A),A
	IN	A,(LPT_A)
	BIT	5,A
	JR	Z,L002	;Printer busy
	LD	A,E
	OUT	(LPT_B),A
	LD	A,5
	OUT	(LPT_A),A
	LD	A,#E2
	OUT	(LPT_A),A
	LD	A,5
	OUT	(LPT_A),A
	LD	A,#E0
	OUT	(LPT_A),A
	EI 
	XOR	A
L004	RET 

;Break printing
L005	LD	A,#97
	SCF 
	RET 

;Relocation table
	DEFW	#FFFF,R000,R001,R002,R003,R004,R005,R006



