
;[BEGIN]
ORG_	ORG	#8000
INCLUDE	"DOS_EQU
	DI 
	XOR	A
	OUT	(#82),A
	LD	A,1
	OUT	(#FD),A
	PUSH	IY
	CALL	TEST
	POP	IY
	XOR	A
	OUT	(#FD),A
	LD	BC,#0080
	LD	E,0
	CALL	#3D13
	EI 
	RET 
	RET 
	RET 

TEST
	LD	C,0
	RST	#10
	LD	HL,ROOT
	LD	C,CHDIR
	RST	#10
	LD	BC,#0100+SETVMOD
	LD	A,3
	RST	#10
	CALL	CLS

START	LD	SP,#BFFF
	CALL	CRLF
	CALL	GETPATH
	EI 
	LD	C,CTRLKEY
	RST	#10
	LD	A,B
	AND	#C0
	JP	NZ,CONSOLE
	LD	HL,BATNAME
	XOR	A
	LD	C,OPEN
	RST	#10
	JP	C,CONSOLE
	LD	(BAT_FM),A

NEWLINE	LD	DE,CMDLINE
ADDBAT	PUSH	DE
	CALL	READBAT
	POP	DE
	OR	A
	JR	NZ,BATLINE
	EX	DE,HL
	LD	DE,CMDLINE
	AND	A
	SBC	HL,DE
	JP	Z,CONSOLE
	LD	A,L
	LD	(CMDLINE-1),A
	CALL	CMDMODE
	LD	C,CLOSE
	LD	A,(BAT_FM)
	RST	#10
	JP	CONSOLE

BATLINE	LD	HL,BATBUFF
NBLINE	CALL	MOVWORD
	JP	C,ADDBAT
	LD	A,B
	LD	(BAT_LEN),A
	PUSH	HL
	EX	DE,HL
	LD	DE,CMDLINE
	AND	A
	SBC	HL,DE
	LD	A,L
	LD	(CMDLINE-1),A
	CALL	CMDMODE
	LD	DE,CMDLINE
	POP	HL
	JP	NBLINE

MOVWORD	LD	A,(BAT_LEN)
	LD	B,A
M00WORD	LD	A,(HL)
	LD	(DE),A
	CP	#20
	JR	C,M01WORD
	INC	HL
	INC	DE
	DJNZ	M00WORD
	SCF 
	RET 

M01WORD	LD	A,(HL)
	CP	#20
	RET	NC
	INC	HL
	DJNZ	M01WORD
	RET 

READBAT	LD	HL,BATBUFF
	LD	DE,128
	LD	C,READ
	LD	A,(BAT_FM)
	RST	#10
	LD	A,E
	LD	(BAT_LEN),A
	RET 

CMDMODE	XOR	A
	LD	(POSIT),A
	LD	IX,CMDLINE-2
	LD	HL,CMDLINE
	LD	A,(HL)
	CP	"@"
	JR	NZ,NOALPHA
	DEC	HL
	DEC	(HL)
	JR	Z,NOEC
	LD	C,(HL)
	INC	HL
	LD	B,0
	LD	D,H
	LD	E,L
	INC	HL
	LDIR 
	JR	NOEC
NOALPHA	LD	A,(ECHOFLG)
	OR	A
	JR	NZ,NOEC
	LD	DE,CMDLINE
	CALL	PRINT_S
	CALL	CRLF
	LD	A,(CMDLINE-1)
	OR	A
	RET	Z
	CALL	CRLF
	CALL	COMPBAT
	RET 

NOEC	LD	A,(CMDLINE-1)
	OR	A
	RET	Z
	CALL	COMPBAT
	RET 

COMPBAT	LD	HL,CMDLINE
	DEC	HL
	LD	C,(HL)
	LD	B,0
	INC	HL
COMP00B	LD	A,(HL)
	CP	" "
	JR	NZ,COMP01B
	INC	HL
	DEC	C
	JR	NZ,COMP00B
	RET 
COMP01B	LD	D,H
	LD	E,L
	ADD	HL,BC
	LD	(HL),0
	SBC	HL,BC
	LD	A,C
	EX	AF,AF'
	LD	A,#20
	CPIR 
	JR	NZ,COMPB05
	INC	C
COMPB05	EX	AF,AF'
	SUB	C
	LD	C,A
	LD	HL,BATLIST
	JP	COMP004

CONSOLE	CALL	CRLF
RE_	CALL	GETXY
	CALL	GETPATH
;	CALL	VERS
	LD	HL,CMDLINE
	LD	DE,CMDLINE+1
	LD	(HL),0
	LD	BC,#7F
	LDIR 
	CALL	INPUT
	CALL	CRLF
	LD	A,(CMDLINE-1)
	OR	A
	JP	Z,RE_
	CALL	CRLF
	CALL	COMP
	JP	RE_

GETXY	LD	C,CURSOR
	RST	#10
	JP	LOCAT

SHIFT	EQU	SH+1

INPUT	XOR	A
	LD	(POSIT),A
	LD	(SHIFT),A
	LD	(LEN_NEW),A
	LD	IX,CMDLINE-2
	CALL	CEDIT
	CALL	RES_CUR
	RET 

COMP	LD	HL,CMDLINE
	DEC	HL
	LD	C,(HL)
	LD	B,0
	INC	HL
COMP00	LD	A,(HL)
	CP	" "
	JR	NZ,COMP01
	INC	HL
	DEC	C
	JR	NZ,COMP00
	RET 
COMP01	LD	D,H
	LD	E,L
	ADD	HL,BC
	LD	(HL),0
	SBC	HL,BC
	LD	A,C
	EX	AF,AF'
	LD	A,#20
	CPIR 
	JR	NZ,COMP005
	INC	C
COMP005	EX	AF,AF'
	SUB	C
	LD	C,A
	LD	HL,CMDLIST
COMP004	PUSH	BC
	PUSH	DE
COMP000	LD	A,(DE)
	CP	#61
	JP	C,COMP001
	CP	#7B
	JP	NC,COMP001
	SUB	#20
COMP001	CP	(HL)
	JP	NZ,COMP002
	INC	HL
	INC	DE
	DEC	C
	JP	NZ,COMP000
	XOR	A
	CP	(HL)
	JP	NZ,COMP002
	POP	BC
	POP	BC
	LD	A,(DE)
	CP	" "
	JR	NZ,NOSPC
	INC	DE
NOSPC	INC	HL
	LD	A,(HL)
	INC	HL
	LD	H,(HL)
	LD	L,A
	JP	(HL)

COMP002	XOR	A
	LD	C,#FF
	CPI 
	JP	NZ,$-2
	INC	HL
	INC	HL
	POP	DE
	POP	BC
	LD	A,(HL)
	OR	A
	JP	NZ,COMP004
	LD	H,D	;CMDLINE
	LD	L,E
	LD	B,(HL)
	INC	HL
	LD	C,(HL)
	INC	HL
	LD	A,(HL)
	OR	A
	JR	NZ,RUN_EXE
	LD	A,":"
	CP	C
	JR	NZ,RUN_EXE
	LD	A,B
	CP	"a"
	JR	C,NOUP
	CP	"{"
	JR	NC,NOUP
	AND	#5F
NOUP	SUB	"A"
	LD	C,CHDISK
	RST	#10
	JP	C,ERROR
	JP	GETPATH

RUN_EXE	EX	DE,HL
	LD	C,EXEC
	RST	#10
	RET	NC
	CP	5
	JP	NC,ERROR
	LD	DE,1
	JP	MESSAGE

BATLIST	DEFB	"PAUSE",0
	DEFW	CPAUSE
	DEFB	"REM",0
	DEFW	CREM
CMDLIST	DEFB	"CD",0
	DEFW	CCHDIR
	DEFB	"CHDIR",0
	DEFW	CCHDIR
	DEFB	"CLS",0
	DEFW	CLS
	DEFB	"DATE",0
	DEFW	CDATE
	DEFB	"DEL",0
	DEFW	CDELET
	DEFB	"DIR",0
	DEFW	DIR
	DEFB	"ECHO",0
	DEFW	CECHO
	DEFB	"ERASE",0
	DEFW	CDELET
	DEFB	"EXIT",0
	DEFW	CEXIT
	DEFB	"HELP",0
	DEFW	HELP
	DEFB	"MD",0
	DEFW	CMKDIR
	DEFB	"MKDIR",0
	DEFW	CMKDIR
	DEFB	"REN",0
	DEFW	CRENAM
	DEFB	"RENAME",0
	DEFW	CRENAM
	DEFB	"RD",0
	DEFW	CRMDIR
	DEFB	"RMDIR",0
	DEFW	CRMDIR
	DEFB	"TIME",0
	DEFW	CTIME
	DEFB	"VERSION",0
	DEFW	VERS
	DEFB	"VER",0
	DEFW	VERS
	DEFB	#00

CLS	LD	DE,#0000
	LD	HL,#2050
	LD	BC,#0700+CLEAR
	LD	A," "
	RST	#10
	LD	DE,#0000
	JP	LOCAT

CRLF	LD	A,#0D
	CALL	PRINTX
	LD	A,#0A
	JP	PRINTX

CDATE	EX	DE,HL
	LD	DE,DTA
	LD	C,GSWITCH
	RST	#10
	LD	DE,DTA
	LD	A,(DE)
	OR	A
	JR	Z,NOSETD
	CALL	STR2DEC
	JR	C,ILLEG
	XOR	A
	CP	H
	JR	NZ,ILLEG
	LD	A,31
	CP	L
	JR	C,ILLEG
	LD	B,L
	PUSH	BC
	CALL	STR2DEC
	POP	BC
	JR	C,ILLEG
	XOR	A
	CP	H
	JR	NZ,ILLEG
	LD	A,12
	CP	L
	JR	C,ILLEG
	LD	C,L
	PUSH	BC
	CALL	STR2DEC
	PUSH	HL
	LD	C,SYSTIME
	RST	#10
	POP	IX
	POP	DE
	LD	C,SETTIME
	RST	#10
NOSETD	LD	HL,DATEMSG
	CALL	PRINTZ
	LD	C,SYSTIME
	RST	#10
	PUSH	IX
	PUSH	DE
	LD	A,D
	CALL	PRNB
	LD	A,"-"
	CALL	PRINTX
	POP	DE
	LD	A,E
	CALL	PRNB
	LD	A,"-"
	CALL	PRINTX
	POP	HL
	CALL	PDIGIT
	CALL	CRLF
	RET 

ILLEG	LD	DE,ILLGMSG
	CALL	MESSAGE
	RET 

CTIME	EX	DE,HL
	LD	DE,DTA
	LD	C,GSWITCH
	RST	#10
	LD	DE,DTA
	LD	A,(DE)
	OR	A
	JR	Z,NOSETT
	CALL	STR2DEC
	JR	C,ILLEG
	XOR	A
	CP	H
	JR	NZ,ILLEG
	LD	A,23
	CP	L
	JR	C,ILLEG
	LD	B,L
	PUSH	BC
	CALL	STR2DEC
	POP	BC
	JR	C,ILLEG
	XOR	A
	CP	H
	JR	NZ,ILLEG
	LD	A,59
	CP	L
	JR	C,ILLEG
	LD	C,L
	PUSH	BC
	CALL	STR2DEC
	POP	BC
	JR	C,ILLEG
	XOR	A
	CP	H
	JR	NZ,ILLEG
	LD	A,59
	CP	L
	JR	C,ILLEG
	PUSH	BC
	LD	A,L
	PUSH	AF
	LD	C,SYSTIME
	RST	#10
	POP	BC
	POP	HL
	LD	C,SETTIME
	RST	#10
NOSETT	LD	HL,TIMEMSG
	CALL	PRINTZ
	LD	C,SYSTIME
	RST	#10
	PUSH	BC
	PUSH	HL
	LD	A,H
	CALL	PRNB
	LD	A,":"
	CALL	PRINTX
	POP	HL
	LD	A,L
	CALL	PRNB
	LD	A,":"
	CALL	PRINTX
	POP	AF
	CALL	PRNB
	CALL	CRLF
	RET 

CPAUSE	LD	DE,PAUSMSG
	CALL	MESSAGE
	LD	C,WAITKEY
	RST	#10
	RET 

CECHO	EX	DE,HL
	LD	A,(HL)
	OR	A
	JR	Z,ECHO_F
	EX	DE,HL
	PUSH	DE
	LD	B,3
	LD	HL,ECHOON
	CALL	COMPARE
	POP	DE
	JR	Z,ECHO_FS
	PUSH	DE
	LD	B,4
	LD	HL,ECHOOFF
	CALL	COMPARE
	POP	HL
	JR	Z,ECHO_FR
	LD	C,PCHARS
	RST	#10
	CALL	CRLF
	JP	CRLF

ECHOON	DEFB	"ON",0
ECHOOFF	DEFB	"OFF",0

ECHO_F	LD	HL,ECHOMSG
	CALL	PRINTZ
	LD	DE,ON_MSG
	LD	A,(ECHOFLG)
	OR	A
	JR	Z,ECHON
	LD	DE,OFF_MSG
ECHON	CALL	MESSAGE
	RET 

ECHO_FS	XOR	A
	LD	(ECHOFLG),A
	RET 

ECHO_FR	LD	A,#FF
	LD	(ECHOFLG),A
	RET 

COMPARE	LD	A,(DE)
	CP	#61
	JP	C,COM001
	CP	#7B
	JP	NC,COM001
	SUB	#20
COM001	CP	(HL)
	RET	NZ
	INC	HL
	INC	DE
	DJNZ	COMPARE
	RET 

CREM	RET 

CCHDIR	EX	DE,HL
	LD	DE,DTA
	LD	C,GSWITCH
	RST	#10
	XOR	A
	LD	HL,DTA
	CP	(HL)
	JR	NZ,YP
	LD	(HL),"."
	INC	HL
	LD	(HL),"."
	INC	HL
	LD	(HL),0
	DEC	HL
	DEC	HL
YP	LD	C,CHDIR
	RST	#10
	CALL	C,ERROR
	CALL	GETPATH
	RET 

CMKDIR	EX	DE,HL
	LD	DE,DTA
	LD	C,GSWITCH
	RST	#10
	LD	HL,DTA
	LD	C,MKDIR
	RST	#10
	CALL	C,ERROR
	RET 

CRMDIR	EX	DE,HL
	LD	DE,DTA
	LD	C,GSWITCH
	RST	#10
	LD	HL,DTA
	LD	C,RMDIR
	RST	#10
	CALL	C,ERROR
	RET 

CDELET	EX	DE,HL
	LD	DE,DTA
	LD	C,GSWITCH
	RST	#10
	LD	HL,DTA
	LD	C,DELETE
	RST	#10
	CALL	C,ERROR
	RET 

CRENAM	EX	DE,HL
	LD	DE,DTA
	LD	C,GSWITCH
	RST	#10
	LD	DE,DTA+128
	LD	C,GSWITCH
	RST	#10
	LD	HL,DTA
	LD	DE,DTA+128
	LD	C,RENAME
	RST	#10
	CALL	C,ERROR
	RET 

ERROR	LD	E,A
	LD	D,0
	JP	MESSAGE

DIR	LD	HL,0
	LD	(FILES),HL
	LD	(S_LOW),HL
	LD	(S_HIGH),HL
	EX	DE,HL
	LD	A,(HL)
	OR	A
	JR	NZ,YPS
	LD	HL,ALLFS
YPS	LD	DE,DTA
	LD	C,GSWITCH
	RST	#10
	LD	HL,DTA
	LD	DE,DTA
	LD	A,#37
	LD	BC,#0000+F_FIRST
	RST	#10
	JR	C,ERRDIR
	LD	HL,DIRMSG1
	CALL	PRINTZ
	LD	A,(PATHF)
	CALL	PRINTX
	LD	HL,DIRMSG2
	CALL	PRINTZ
	CALL	GETPATH
	LD	HL,PATHF
	CALL	PRINTZ
	CALL	CRLF
	CALL	CRLF
DIRNEX	LD	HL,DTA
	LD	DE,33
	ADD	HL,DE
	CALL	PNAME
	LD	IX,DTA
	LD	A,(IX+32)
	AND	#10
	JP	NZ,NODADD
	LD	HL,(FILES)
	INC	HL
	LD	(FILES),HL
	LD	E,(IX+30)
	LD	D,(IX+31)
	LD	HL,(S_HIGH)
	EXX 
	LD	E,(IX+28)
	LD	D,(IX+29)
	LD	HL,(S_LOW)
	CALL	ADDXXX
	LD	(S_LOW),HL
	EXX 
	LD	(S_HIGH),HL
NODADD	LD	DE,DTA
	LD	C,F_NEXT
	RST	#10
	JR	NC,DIRNEX
	CALL	ORDERS
	CALL	CRLF
	RET 

ERRDIR	LD	DE,3
	CALL	MESSAGE
	RET 

ORDERS	LD	A," "
	LD	B,8
	CALL	PRINT_B
	LD	HL,(FILES)
	CALL	PDIGIT
	LD	HL,FILEMSG
	CALL	PRINTZ
	LD	HL,(S_LOW)
	EXX 
	LD	HL,(S_HIGH)
	EXX 
	CALL	MAKE_LN
	LD	HL,L32BIT_+9
	LD	A,(HL)
	CP	#20
	JR	NZ,ALR2
	LD	A,#30
	LD	(HL),A
ALR2	LD	DE,SIZEBFF
	LD	HL,L32BIT_;; +1
	LD	A,(HL)
	LDI 
	CP	" "
	JR	Z,NOPO1
	LD	A,"."
NOPO1	LD	(DE),A
	INC	DE
	LDI 
	LDI 
	LD	A,(HL)
	LDI 
	CP	" "
	JR	Z,NOPO2
	LD	A,"."
NOPO2	LD	(DE),A
	INC	DE
	LDI 
	LDI 
	LD	A,(HL)
	LDI 
	CP	" "
	JR	Z,NOPO3
	LD	A,"."
NOPO3	LD	(DE),A
	INC	DE
	LDI 
	LDI 
	LDI 
	LD	HL,SIZEBFF
	CALL	PRINTZ
	LD	HL,BYTEMSG
	JP	PRINTZ

FILEMSG	DEFB	" file(s) ",0

BYTEMSG	DEFB	" bytes",#0D,#0A,0

;HL':HL	+ DE':DE

ADDXXX	ADD	HL,DE
	EXX 
	ADC	HL,DE
	EXX 
	RET 

FILES	DEFW	0

S_LOW	DEFW	0
S_HIGH	DEFW	0

PNAME	LD	B,8
	CALL	PRINTB
	LD	A," "
	CALL	PRINTX
	LD	B,3
	CALL	PRINTB
	LD	A," "
	CALL	PRINTX
	LD	IX,DTA
	CALL	PRNSIZE
	LD	A," "
	CALL	PRINTX
	LD	A," "
	CALL	PRINTX
	CALL	PRNDATE
	LD	A," "
	CALL	PRINTX
	LD	A," "
	CALL	PRINTX
	CALL	PRNTIME
	JP	CRLF

PRINTB	LD	A,(HL)
	PUSH	BC
	CALL	PRINTX
	POP	BC
	INC	HL
	DJNZ	PRINTB
	RET 
;------------------

PRNB	LD	C,#2F
PRNB1	INC	C
	SUB	10
	JP	NC,PRNB1
	ADD	A,10
	ADD	A,#30
	PUSH	AF
	LD	A,C
	CALL	PRINTX
	POP	AF
	JP	PRINTX

STR2DEC	LD	HL,0
STRLOOP	LD	A,(DE)
	INC	DE
	OR	A
	RET	Z
	CP	"-"
	RET	Z
	CP	":"
	RET	Z
	LD	B,H
	LD	C,L
	ADD	HL,HL
	ADD	HL,HL
	ADD	HL,BC
	ADD	HL,HL
	CALL	ATODEC
	RET	C
	ADD	A,L
	LD	L,A
	JR	NC,STRLOOP
	INC	H
	JR	STRLOOP

ATODEC	CP	"0"
	RET	C
	CP	":"
	CCF 
	RET	C
	SUB	"0"
	RET 

PDIGIT	LD	DE,10000
	LD	A,#C8
	LD	(RET_Z),A
	CALL	DIG
	LD	DE,1000
	CALL	DIG
	LD	DE,100
	CALL	DIG
	LD	DE,10
	CALL	DIG
	LD	A,L
	ADD	A,#30
	JP	PRINTX

DIG	XOR	A
DIG1	INC	A
	SBC	HL,DE
	JR	NC,DIG1
	ADD	HL,DE
	DEC	A
RET_Z	RET	Z
	ADD	A,#30
	PUSH	HL
	CALL	PRINTX
	POP	HL
	LD	A,0
	LD	(RET_Z),A
	RET 

PRNSIZE	LD	A,(IX+32)
	LD	HL,DIRIDD
	AND	#10
	JP	NZ,PRINTZ
	LD	L,(IX+28)
	LD	H,(IX+29)
	EXX 
	LD	L,(IX+30)
	LD	H,(IX+31)
	EXX 
	PUSH	IX
	CALL	MAKE_LN
	LD	HL,L32BIT_+9
	LD	A,(HL)
	CP	#20
	JR	NZ,ALR
	LD	A,#30
	LD	(HL),A
ALR	LD	DE,SIZEBFF
	LD	HL,L32BIT_;; +1
	LDI 
	LD	A," "
	LD	(DE),A
	INC	DE
	LDI 
	LDI 
	LDI 
	LD	(DE),A
	INC	DE
	LDI 
	LDI 
	LDI 
	LD	(DE),A
	INC	DE
	LDI 
	LDI 
	LDI 
	LD	HL,SIZEBFF
	POP	IX
	JP	PRINTZ

PRNDATE	LD	B,(IX+25)
	LD	C,(IX+24)
	LD	HL,SIZEBFF
	CALL	DATE
	LD	(HL),0
	LD	HL,SIZEBFF
	LD	A,(HL)
	CP	"0"
	JP	NZ,PRINTZ
	LD	(HL),#20
	JP	PRINTZ

PRNTIME	LD	B,(IX+22)
	LD	C,(IX+23)
	LD	HL,SIZEBFF
	CALL	TIME
	LD	(HL),0
	LD	HL,SIZEBFF
	LD	A,(HL)
	CP	"0"
	JP	NZ,PRINTZ
	LD	(HL),#20
	JP	PRINTZ

TIME
	SRL	C
	RR	B
	SRL	C
	RR	B
	SRL	C
	RR	B
	SRL	B
	SRL	B
	LD	A,C
	CALL	NUMB
	LD	(HL),":"
	INC	HL
	LD	A,B
	JP	NUMB

DATE
	LD	A,C
	AND	#1F
	PUSH	BC
	CALL	NUMB
	LD	(HL),"."
	INC	HL
	POP	BC
	LD	A,C
	SRL	B
	RLA 
	RLA 
	RLA 
	RLA 
	AND	#0F
	CALL	NUMB
	LD	(HL),"."
	INC	HL
	LD	A,B
	ADD	A,#50
	CP	100
	JP	C,NUMB
SUB100	SUB	100
	CP	100
	JP	C,NUMB
	JR	SUB100

NUMB	LD	C,#2F
NUMB1	INC	C
	SUB	10
	JP	NC,NUMB1
	ADD	A,10
	ADD	A,#30
	LD	(HL),C
	INC	HL
	LD	(HL),A
	INC	HL
	RET 

MAKE_LN	LD	IX,L32BIT_
	EXX 
	LD	DE,#3B9A ; 1000000000
	EXX 
	LD	DE,#CA00
	CALL	GET_DIG
	EXX 
	LD	DE,#05F5 ; 100000000
	EXX 
	LD	DE,#E100
	CALL	GET_DIG
	EXX 
	LD	DE,#0098 ; 10000000
	EXX 
	LD	DE,#9680
	CALL	GET_DIG
	EXX 
	LD	DE,#000F ; 1000000
	EXX 
	LD	DE,#4240
	CALL	GET_DIG
	EXX 
	LD	DE,#0001 ; 100000
	EXX 
	LD	DE,#86A0
	CALL	GET_DIG
	EXX 
	LD	DE,#0000 ; 10000
	EXX 
	LD	DE,#2710
	CALL	GET_DIG
	EXX 
	LD	DE,#0000 ; 1000
	EXX 
	LD	DE,#03E8
	CALL	GET_DIG
	EXX 
	LD	DE,#0000 ; 100
	EXX 
	LD	DE,#0064
	CALL	GET_DIG
	EXX 
	LD	DE,#0000 ; 10
	EXX 
	LD	DE,#000A
	CALL	GET_DIG
	LD	A,L	 ; 1
	ADD	A,#30
	LD	(IX),A
	INC	IX
	LD	HL,L32BIT_
	LD	DE,#2030
KILLZ	LD	A,(HL)
	CP	E
	JR	NZ,KILLZ2
	LD	(HL),D
	INC	HL
	JP	KILLZ
KILLZ2	LD	HL,L32BIT_+9
	LD	A,(HL)
	CP	D
	RET	NZ
	LD	(HL),E
	RET 

; HL:HL	- DE:DE

GET_DIG	XOR	A
INC_DG	INC	A
	SBC	HL,DE
	EXX 
	SBC	HL,DE
	EXX 
	JP	NC,INC_DG
	ADD	HL,DE
	EXX 
	ADC	HL,DE
	EXX 
	DEC	A
	ADD	A,#30
	LD	(IX),A
	INC	IX
	RET 

L32BIT_	DEFB	"0000000000"

DIRIDD	DEFB	"<DIR>	      ",0

SIZEBFF	DEFB	"0 000 000 000",0,0

;-------------------

VERS	LD	HL,DOSVER
	CALL	PRINTZ
	LD	C,VERSION
	RST	#10
	LD	A,D
	CALL	GETDD
	ADD	A,"0"
	CALL	PRINTX
	LD	A,"."
	CALL	PRINTX
	LD	A,E
	CALL	GETDD
	ADD	A,"0"
	CALL	PRINTX
	CALL	CRLF
	JP	CRLF

GETDD	LD	B,#00
GETD	INC	B
	SUB	10
	JR	NC,GETD
	ADD	A,10
	DEC	B
	RET	Z
	PUSH	AF
	LD	A,B
	ADD	A,"0"
	CALL	PRINTX
	POP	AF
	RET 

HELP	LD	DE,0
	CALL	MESSAGE
	RET 

CEXIT  ;POP	HL
	RET 

MESSAGE	INC	DE
	LD	HL,ERRORS
	LD	BC,END_ERR-ERRORS
LCPIR	XOR	A
	CPIR 
	RET	NZ
	DEC	DE
	LD	A,D
	OR	E
	JP	NZ,LCPIR
	CALL	PRINTZ
	CALL	CRLF
	JP	CRLF

ROOT	DEFB	"C:\",0

ALLFS	DEFB	"*.*",0

ECHOMSG	DEFB	"Echo is ",0

DATEMSG	DEFB	"Current date: ",0
TIMEMSG	DEFB	"Current time: ",0

DIRMSG1	DEFB	"Volume	in drive ",0
DIRMSG2	DEFB	" has no label",#0D,#0A
	DEFB	"Volume	Serial number is C37F-73AB",#0D,#0A
	DEFB	"Directory of ",0

DOSVER	DEFB	"DOS version ",0

ON_MSG	EQU	42
OFF_MSG	EQU	43
PAUSMSG	EQU	44
ILLGMSG	EQU	47

ERRORS	DEFB	#00
	DEFB	"COMMANDS:",#0D,#0A,#0D,#0A
	DEFB	"CD	 DEL	 HELP	 REN	 VER	 "
	DEFB	"					",#0D,#0
?A
	DEFB	"CHDIR	 DIR	 MD	 RENAME	 VERSION "
	DEFB	"					",#0D,#0
?A
	DEFB	"CLS	 ERASE	 MKDIR	 RMDIR		 "
	DEFB	"					",#0D,#0
?A
	DEFB	"DATE	 EXIT	 RD	 TIME		 "
	DEFB	"					"
	DEFB	0
	DEFB	"Bad command or	file name",0
	DEFB	"Invalid drive number",0
	DEFB	"File not found",0
	DEFB	"Path not found",0
	DEFB	"Extended error	5",0
	DEFB	"Extended error	6",0
	DEFB	"File exist",0
	DEFB	"File read only",0
	DEFB	"Root overflow",0
	DEFB	"No free space",0
	DEFB	"Directory not empty",0
	DEFB	"Can't delete current directory",0
	DEFB	"Unknow	format",0
	DEFB	"Unknow	operation",0
	DEFB	"Directory exist",0
	DEFB	"Bad file name",0
	DEFB	"Bad EXE-file",0
	DEFB	"Not support EXE-file",0
	DEFB	"Extended error	19",0
	DEFB	"Extended error	20",0
	DEFB	"Extended error	21",0
	DEFB	"Extended error	22",0
	DEFB	"Extended error	23",0
	DEFB	"Extended error	24",0
	DEFB	"Extended error	25",0
	DEFB	"Extended error	26",0
	DEFB	"Extended error	27",0
	DEFB	"Extended error	28",0
	DEFB	"Extended error	29",0
	DEFB	"No free memory",0
	DEFB	"Extended error	31",0
	DEFB	"Extended error	32",0
	DEFB	"Extended error	33",0
	DEFB	"Extended error	34",0
	DEFB	"35",0
	DEFB	"36",0
	DEFB	"37",0
	DEFB	"38",0
	DEFB	"39",0
	DEFB	"40",0
	DEFB	"Echo is ",0
	DEFB	"on",0
	DEFB	"off",0
	DEFB	"Press any key to continue . . .",0
	DEFB	"45",0
	DEFB	"46",0
	DEFB	"Invalid parametr",0
	DEFB	"48",0
	DEFB	"49",0
	DEFB	"50"
	DEFB	0

END_ERR

DTA	DEFS	256,0

PATHF	DEFS	256,0

BAT_FM	DEFB	0
BAT_LEN	DEFB	0

ECHOFLG	DEFB	0

PATHLEN	DEFB	0
PATH	DEFS	40,0

GETPATH	LD	C,2
	RST	#10
	LD	HL,PATHF
	ADD	A,"A"
	LD	(HL),A
	INC	HL
	LD	(HL),":"
	INC	HL
	LD	C,30
	RST	#10
	LD	HL,PATHF
	LD	DE,PATH
	LDI 
	LDI 
	LDI 
	PUSH	HL
	XOR	A
	LD	BC,34
	CPIR 
	JP	NZ,LONGP
	LD	A,34
	SUB	C
	LD	C,A
	POP	HL
	LDIR 
	JR	PHLEN

LONGP	CPIR 
	LD	A,"."
	LD	(DE),A
	INC	DE
	LD	(DE),A
	INC	DE
	LD	(DE),A
	INC	DE
	LD	BC,31
	AND	A
	SBC	HL,BC
	LDIR 
	POP	HL
PHLEN	LD	HL,PATH
	LD	BC,40
	XOR	A
	CPIR 
	LD	A,39
	SUB	C
	LD	(PATHLEN),A
	LD	C,A
	INC	C
	INC	C
	LD	A,80
	SUB	C
	LD	(WINDOW),A
	RET 
PRINT_B	LD	C,A
PRINTBB	PUSH	BC
	CALL	PRINTX
	POP	BC
	LD	A,C
	DJNZ	PRINTBB
	RET 

PRINTZ	LD	A,(HL)
	OR	A
	RET	Z
	PUSH	HL
	CALL	PRINTX
	POP	HL
	INC	HL
	JP	PRINTZ

TEMPXY	DEFW	0

CR_	LD	C,CURSOR
	RST	#10
	LD	E,0
	JP	LOCAT

LF_	LD	C,CURSOR
	RST	#10
	LD	A,D
	CP	#1F
	JP	Z,LFF
	INC	D
	JP	LOCAT

LFF	PUSH	HL
	PUSH	DE
	LD	BC,#018A
	LD	DE,#0020
	EI 
	HALT 
	DI 
	RST	#08
	LD	DE,#1F00
	CALL	LOCAT
	LD	A,#20
	LD	BC,#5082
	RST	#08
	EI 
	POP	DE
	CALL	LOCAT
	POP	HL
	RET 

PRINTX	CP	#20
	JP	NC,CHAR
	CP	#0D
	JP	Z,CR_
	CP	#0A
	JP	Z,LF_
CHAR	PUSH	BC
	LD	BC,#0182
	RST	#08
	POP	BC
	RET 

LOCAT	LD	(TEMPXY),DE
	LD	C,LOCATE
	RST	#10
	RET 

;PRINTX	 LD	 C,PUTCHAR
;	 RST	 #10
;	 RET

CEDIT	PUSH	IX
	POP	HL
	INC	HL
	INC	HL
	LD	(ETXS),HL
	XOR	A
	LD	(POSIT),A
	LD	(SHIFT),A
EDIT1	LD	DE,(ETXS)
	CALL	PRINT_S
	CALL	KEY
	CP	13
	RET	Z
	LD	HL,EDIT1
	PUSH	HL
	AND	A
	LD	HL,#5400
	SBC	HL,DE
	JP	Z,BACK
	AND	A
	LD	HL,#5600
	SBC	HL,DE
	JP	Z,FORW
	CP	#08
	JP	Z,DELET
	CP	#20
	RET	C
	EX	AF,AF'
	LD	A,(IX+1)
	CP	(IX+0)
	CCF 
	RET	C
	LD	A,(IX+1)
	LD	E,A
	LD	D,0
	LD	HL,(ETXS)
	ADD	HL,DE
	LD	A,(POSIT)
	LD	E,A
	LD	A,(IX+1)
	SUB	E
	JR	Z,ADD_SM
	LD	B,D
	LD	C,A
	LD	D,H
	LD	E,L
	DEC	HL
	LDDR 
	EX	DE,HL
ADD_SM	EX	AF,AF'
	LD	(HL),A
	LD	A,(POSIT)
	INC	A
	LD	(POSIT),A
	LD	(MAIN_X),A
	INC	(IX+1)
	LD	HL,(ETXE)
	INC	HL
	LD	(ETXE),HL
	LD	HL,SHIFT
	SUB	(HL)
	CP	(IX-1)
	RET	C
	LD	A,(STEP)
	ADD	A,(HL)
	LD	(HL),A
;	CALL	PAGE
	RET 

BACK	LD	A,(POSIT)
	OR	A
	RET	Z	;JP Z,BCK
	DEC	A
	LD	(POSIT),A
	LD	(MAIN_X),A
	INC	A
	LD	HL,SHIFT
	SUB	(HL)
	RET	NZ
	LD	A,(STEP)
	LD	E,A
	LD	A,(HL)
	SUB	E
	LD	(HL),A
;	CALL	PAGE
	RET 

FORW	LD	A,(POSIT)
	CP	(IX+1)
	RET	Z	; JP	  Z,FRD
	INC	A
	LD	(POSIT),A
	LD	(MAIN_X),A
	LD	HL,SHIFT
	SUB	(HL)
	CP	(IX-1)
	RET	C
	LD	A,(STEP)
	ADD	A,(HL)
	LD	(HL),A
;	CALL	PAGE
	RET 

DELET	LD	A,(POSIT)
	OR	A
	RET	Z	; JP	  Z,LINKSTR
	LD	HL,(ETXS)
	LD	E,A
	LD	D,0
	ADD	HL,DE
	LD	A,(IX+1)
	SUB	E
	JR	Z,SUB_SM
	LD	B,D
	LD	C,A
	LD	D,H
	LD	E,L
	DEC	DE
	LDIR 
SUB_SM	XOR	A
	DEC	HL
	LD	(HL),A
	LD	A,(POSIT)
	DEC	A
	LD	(POSIT),A
	LD	(MAIN_X),A
	DEC	(IX+1)
	LD	HL,(ETXE)
	DEC	HL
	LD	(ETXE),HL
	LD	HL,SHIFT
	INC	A
	SUB	(HL)
	RET	NZ
	LD	A,(STEP)
	LD	E,A
	LD	A,(HL)
	SUB	E
	LD	(HL),A
;	CALL	PAGE
	RET 

KEY    ;RES	5,(IY+1)
	LD	A,(SHIFT)
	LD	E,A
	LD	A,(POSIT)
	SUB	E
	INC	A
	LD	HL,PATHLEN
	ADD	A,(HL)
	LD	(_X+1),A
	LD	A,(POSIT)
	CP	(IX+1)
	JP	C,KEY0
	LD	A,#20
	LD	(_A+1),A
	JP	KEY1
KEY0	LD	E,A
	LD	D,0
	LD	HL,(ETXS)
	ADD	HL,DE
	LD	A,(HL)
	LD	(_A+1),A
KEY1	CALL	CURSORF
	EI 
	HALT 
	LD	C,SCANKEY
	RST	#10
	JP	Z,KEY1
	RET 

CURSORX	DEFB	#00

CURSORF	LD	A,05
	DEC	A
	LD	(CURSORF+1),A
	RET	NZ
	LD	A,05
	LD	(CURSORF+1),A
	LD	DE,(TEMPXY)
_X	LD	E,#00
	CALL	LOCAT
	LD	A,(CURSORX)
	XOR	#FF
	LD	(CURSORX),A
	LD	A,"_"
	JR	NZ,YEPCUR
_A	LD	A,#20
YEPCUR	CALL	PRINTX
	EI 
	RET 

RES_CUR	LD	A,(CURSORX)
	OR	A
	RET	Z
	XOR	#FF
	LD	(CURSORX),A
	LD	DE,(TEMPXY)
	LD	A,(_X+1)
	LD	E,A
	CALL	LOCAT
	LD	A,(_A+1)
	JP	PRINTX

PRINT_S	PUSH	DE
	LD	DE,(TEMPXY)
	LD	E,0
	CALL	LOCAT
	LD	HL,PATH
	CALL	PRINTZ
	LD	A,">"
	CALL	PRINTX
	POP	DE
	EX	DE,HL
SH	LD	BC,#0000
	ADD	HL,BC
	LD	A,(SHIFT)
	LD	C,A
	LD	A,(IX+1)
	SUB	C
	JP	Z,EMT_STR
	LD	B,A
	LD	A,(IX-1)
	SUB	B
	JR	NC,PR_S
	LD	B,(IX-1)
PR_S	PUSH	BC
	LD	C,#86
	RST	#08
	POP	BC
EMT_STR	LD	A,(IX-1)
	SUB	B
	EI 
	RET	Z
	LD	B,A
	LD	C,#82
	LD	A,#20
	RST	#08
	EI 
	RET 

BATNAME	DEFB	"system.bat",0

STEP	DEFB	8
MAIN_X	DEFB	0

LEN_OLD	DEFB	#00
POSIT	DEFB	#00
ETXS	DEFW	0
ETXE	DEFW	0
;	+0 - Size buffer
;	+1 - Amount simbols
;	-1 - Scroll Window
WINDOW	DEFB	#50
BUFFERC	DEFB	#FF
LEN_NEW	DEFB	#00
CMDLINE	DEFS	#100,0

BATBUFF	DEFS	129,0


	ORG	#C000
	INCBIN "  DOS_OBJ
	ORG	ORG_



