
;[BEGIN]
;//MODULE: DOS5
;//CREATE: 19-05-1998	AUTHOR:	Denis Parinov
;//UPDATE: 24-10-1999	DNS	Restore	module
;R01	   16-12-1999	DNS	Y2K fix

; INPUT: HL - "C:\DIR1\DIR2\filename.ext",#00
;	  A - ATTRIB
;	  B - MODE
;	  B = 0	GET ATTRIB
;	  B = 1	SET ATTRIB
; OUTPUT: A - ATTRIB

ATTRIB	INC	B
	DEC	B
	JP	Z,RATTRIB
	DEC	B
	JP	Z,WATTRIB
	LD	A,1
	SCF 
	RET 

RATTRIB	LD	A,0
	CALL	OPEN
	RET	C
	LD	B,(IY+ATR)
	PUSH	BC
	CALL	CLOSE
	POP	BC
	RET	C
	LD	A,B
	AND	A
	RET 

WATTRIB	PUSH	AF
	LD	A,0
	CALL	OPEN
	POP	BC
	RET	C
	SET	7,(IY+AMODE)
	LD	(IY+ATR),B
	PUSH	BC
	CALL	CLOSE
	POP	BC
	RET	C
	LD	A,B
	AND	A
	RET 

; INPUT: HL - "C:\DIR1\DIR2\filename.ext",#00
; OUTPUT: A - FM

CREATE	LD	(ACCESS),A
	LD	(PATH0),HL
	CALL	GETWORD
	RET	C
	LD	HL,TMPNAME
	LD	DE,MASKARE
	CALL	MASK
	RET	C
	CALL	SEARCH
	JP	C,CREAT		;NO FILE, CREAT	NEW.
	CALL	DELFILE		;FILE EXIST RECREAT
	JP	CREAT

; INPUT: HL - "C:\DIR1\DIR2\filename.ext",#00
; OUTPUT: A - FM

CREAT_N	LD	(ACCESS),A
	LD	(PATH0),HL
	CALL	GETWORD
	RET	C
	LD	HL,TMPNAME
	LD	DE,MASKARE
	CALL	MASK
	RET	C
	CALL	SEARCH
	LD	A,7
	CCF 
	RET	C
CREAT	LD	HL,MASKARE
	LD	DE,HANDBUF
	LD	BC,11
	LDIR 
	EX	DE,HL
	LD	A,(ACCESS)
	LD	(HL),A
	INC	HL
	LD	BC,#0A00
FIHND	LD	(HL),C
	INC	HL
	DJNZ	FIHND
	PUSH	HL
	CALL	SYSTIME
	CALL	MK_TIME
	POP	HL
	LD	(HL),E
	INC	HL
	LD	(HL),D
	INC	HL
	LD	(HL),C
	INC	HL
	LD	(HL),B
	INC	HL
	LD	BC,#0600
FIHND1	LD	(HL),C
	INC	HL
	DJNZ	FIHND1
	CALL	WRT_HND
	CALL	SAVEDIR
	LD	HL,(PATH0)
	XOR	A
	JP	OPEN

; INPUT: HL - "filename.ext",#00 without simbols * ?

DELETE	LD	DE,MASKARE
	CALL	MASK
	RET	C
	LD	HL,MASKARE
	LD	BC,11
	LD	A,"?"
	CPIR 
	LD	A,16
	SCF 
	RET	Z
	CALL	LOADDIR
	CALL	SEARCH
	RET	C
DELFILE	LD	A,DIRPAGE
	CALL	BANK
	PUSH	AF
	LD	(IX+NAM),#E5
	LD	E,(IX+CLU1)
	LD	D,(IX+CLU2)
	POP	AF
	OUT	(PAGE3),A
	LD	A,E
	OR	D
	JR	Z,SMALDEL
DEL01	EX	DE,HL
	CALL	R_F_FAT
	PUSH	DE
	PUSH	AF
	LD	DE,#0000
	CALL	W_T_FAT
	POP	AF
	POP	DE
	JP	NC,DEL01
	CALL	WR_FAT
SMALDEL	CALL	SAVEDIR
	AND	A
	RET 

; INPUT: HL - "old_name.ext",#00 without simbols * ?
;	 DE - "new_name.ext",#00 without simbols * ?

RENAME	PUSH	DE
	LD	DE,MASKARE
	CALL	MASK
	POP	DE
	RET	C
	LD	HL,MASKARE
	LD	BC,11
	LD	A,"?"
	CPIR 
	LD	A,16
	SCF 
	RET	Z
	PUSH	DE
	CALL	LOADDIR
	LD	A,#33
	CALL	ASEARCH
	POP	HL
	RET	C
	LD	DE,MASKARE
	CALL	MASK
	RET	C
	LD	HL,MASKARE
	LD	BC,11
	LD	A,"?"
	CPIR 
	LD	A,16
	SCF 
	RET	Z
	PUSH	IX
	LD	A,#33
	CALL	ASEARCH
	POP	IX
	LD	A,7
	CCF 
	RET	C
	LD	A,DIRPAGE
	CALL	BANK
	LD	HL,MASKARE
	LD	D,HX
	LD	E,LX
	LD	BC,11
	LDIR 
	OUT	(PAGE3),A
	CALL	SAVEDIR
	AND	A
	RET 


OPEN	LD	(ACCESS),A
	CALL	GETWORD
	RET	C
	LD	HL,TMPNAME
	LD	DE,MASKARE
	CALL	MASK
	RET	C
OPENEXE	CALL	SEARCH
	RET	C
	CALL	GET_FM
	RET	C
	LD	A,C
	EX	AF,AF'
	EXX 
	LD	(IY+HND1),E
	LD	(IY+HND2),D
	EXX 
	LD	D,HY
	LD	E,LY
	LD	HL,HANDBUF
	LD	BC,#0020
	LDIR 
	LD	A,(ACCESS)
	LD	(IY+AMODE),A
	LD	A,(TASK)
	LD	(IY+FTASK),A
	XOR	A
	LD	(IY+POS1),A
	LD	(IY+POS2),A
	LD	(IY+POS3),A
	LD	(IY+POS4),A
	LD	A,(DRIVE)
	LD	(IY+FDRV),A
	LD	HL,FM_BUF+CLU1
	LD	E,(HL)
	INC	HL
	LD	D,(HL)
	LD	(IY+DIRCLU1),E
	LD	(IY+DIRCLU2),D
	EX	AF,AF'
	AND	A
	RET 

CLOSE	LD	(ACCESS),A
	CALL	SET_FM
	RET	C
	LD	A,(TASK)
	CP	(IY+FTASK)
	LD	A,19
	SCF 
	RET	NZ
	BIT	7,(IY+AMODE)
	JR	Z,NOTMODF
	LD	D,(IY+DIRCLU1)
	LD	E,(IY+DIRCLU2)
	PUSH	DE
	XOR	A
	CALL	SET_FM
	POP	DE
	LD	(IY+DIRCLU1),D
	LD	(IY+DIRCLU2),E
	CALL	LOADDIR
	LD	A,(ACCESS)
	CALL	SET_FM
	LD	HL,DIR
	LD	DE,#0020
	LD	C,(IY+HND1)
	LD	B,(IY+HND2)
	JR	CLOSE2
CLOSE1	ADD	HL,DE
	DEC	BC
CLOSE2	LD	A,B
	OR	C
	JR	NZ,CLOSE1
	LD	D,HY
	LD	E,LY
	EX	DE,HL
	PUSH	HL
	LD	A,DIRPAGE
	CALL	BANK
	POP	HL
	LD	BC,#0020
	LDIR 
	OUT	(PAGE3),A
	CALL	SAVEDIR
NOTMODF	LD	A,(ACCESS)
	CALL	RES_FM
	RET 

PATH0	DEFW	#0000

ACCESS	DEFB	#00

HANDBUF	DEFB	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DEFB	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0


WRT_HND	LD	A,DIRPAGE
	CALL	BANK
	PUSH	AF
	LD	IX,DIR
	EXX 
	LD	DE,0
	EXX 
WRT_HN1	LD	A,(IX+00)
	OR	A
	JR	Z,WRT_HN2
	CP	#E5
	JR	Z,WRT_HN2
	LD	BC,#0020
	ADD	IX,BC
	JR	NC,WRT_HN1
	POP	AF
	OUT	(PAGE3),A
	LD	A,9
	SCF 
	RET 

WRT_HN2	LD	D,HX
	LD	E,LX
	LD	HL,HANDBUF
	LD	BC,#0020
	LDIR 
	POP	AF
	OUT	(PAGE3),A
	LD	HL,DIR
	LD	BC,(DIRSIZE)
	DEC	BC
	ADD	HL,BC
	AND	A
	SBC	HL,DE
	RET	NC
	LD	HL,(DIRSIZE)
	LD	BC,(B_P_C)
	ADD	HL,BC
	LD	(DIRSIZE),HL
	AND	A
	RET 

DOSNAME	INC	B
	DEC	B
	JP	Z,GETNAME
	DEC	B
	JP	Z,MASK
	LD	A,1
	SCF 
	RET 

; HL - 11 bytes	filename "FILENAMEEXT"
; DE - DOS filename "FILENAME.EXT",0

GETNAME	LD	BC,#08FF
GETN1	LD	A,(HL)
	CP	" "
	JR	NZ,GETN3
GETN2	INC	HL
	DJNZ	GETN2
	JR	GETN4
GETN3	LDI 
	DJNZ	GETN1
GETN4	LD	A,(HL)
	CP	" "
	LD	A,"."
	JR	NZ,GETN5
	LD	A,#00
GETN5	LD	(DE),A
	INC	DE
	RET	Z
	LD	B,#03
GETN6	LD	A,(HL)
	CP	" "
	RET	Z
	LDI 
	XOR	A
	LD	(DE),A
	DJNZ	GETN6
	RET 

DTABUF	DEFW	#0000
CURHND	DEFW	#0000
NO_NEXT	DEFB	#00
FNDMODE	DEFB	#00

F_FIRST	LD	(ACCESS),A
	LD	(DTABUF),DE
	LD	A,B
	LD	(FNDMODE),A
	PUSH	HL
	CALL	LOADDIR
	POP	HL
	CALL	GETWORD
	RET	C
	LD	HL,TMPNAME
	LD	DE,MASKARE
	CALL	MASK
	RET	C
	LD	A,(ACCESS)
	CALL	ASEARCH
	RET	C
	LD	HL,MASKARE
	LD	DE,(DTABUF)
	LD	BC,11
	LDIR 
	LD	A,(ACCESS)
	LD	(DE),A
	INC	DE
FIND_S	LD	BC,#0020
	ADD	IX,BC
	LD	(CURHND),IX
	LD	HL,HANDBUF+12
	LD	BC,20
	LDIR 
	LD	A,(HANDBUF+11)
	LD	(DE),A
	INC	DE
	LD	HL,HANDBUF
	LD	A,(FNDMODE)
	OR	A
	JR	NZ,FIND_M2
	LD	BC,11
	LDIR 
	LD	A,#FF
	LD	(NO_NEXT),A
	XOR	A
	RET 
FIND_M2	CALL	GETNAME
	LD	A,#FF
	LD	(NO_NEXT),A
	XOR	A
	RET 

F_NEXT	LD	A,(NO_NEXT)
	OR	A
	LD	A,14
	SCF 
	RET	Z
	LD	(DTABUF),DE
	LD	DE,MASKARE
	LD	HL,(DTABUF)
	LD	BC,11
	LDIR 
	LD	A,(HL)
	PUSH	HL
	CALL	NSEARCH
	POP	DE
	EX	AF,AF'
	XOR	A
	LD	(NO_NEXT),A
	EX	AF,AF'
	RET	C
	INC	DE
	JP	FIND_S

NSEARCH	EX	AF,AF'
	LD	A,DIRPAGE
	CALL	BANK
	PUSH	AF
	EX	AF,AF'
	CPL 
	LD	C,A
	LD	IX,(CURHND)
	EXX 
	LD	DE,0
	EXX 
	JP	SEARCH1

DSEARCH	LD	A,#10
	CALL	ASEARCH
	RET	NC
	LD	A,4
	RET 

SEARCH	LD	A,#23
ASEARCH	EX	AF,AF'
	LD	A,DIRPAGE
	CALL	BANK
	PUSH	AF
	EX	AF,AF'
	CPL 
	LD	C,A
	LD	IX,DIR
	EXX 
	LD	DE,0
	EXX 
SEARCH1	LD	A,(IX+00)
	OR	A
	JR	Z,SEARCH4
	CP	#E5
	JR	Z,SEARCH3
	LD	A,(IX+11)
	AND	C
	JR	NZ,SEARCH3
	LD	HL,MASKARE
	LD	D,HX
	LD	E,LX
	LD	B,11
	EX	DE,HL
SEARCH2	LD	A,(DE)
	CP	"?"
	JR	Z,SEARCH5
	CP	(HL)
	JR	NZ,SEARCH3
SEARCH5	INC	HL
	INC	DE
	DJNZ	SEARCH2
	LD	D,HX
	LD	E,LX
	LD	HL,HANDBUF
	EX	DE,HL
	LD	BC,#0020
	LDIR 
	POP	AF
	OUT	(PAGE3),A
	AND	A
	RET 

SEARCH3	EXX 
	INC	DE
	EXX 
	LD	DE,#0020
	ADD	IX,DE
	JR	NC,SEARCH1
SEARCH4	POP	AF
	OUT	(PAGE3),A
	LD	A,3
	SCF 
	RET 

GETWORD	LD	DE,TMPNAME
	LD	BC,#0DFF
GETWRD1	LD	A,(HL)
	INC	HL
	CP	"\"
	JR	Z,DIRNAME
	CP	":"
	JR	Z,DRVNAME
	LD	(DE),A
	INC	DE
	CP	#21
	CCF 
	RET	NC
	DJNZ	GETWRD1
	LD	A,16
	SCF 
	RET 

DIRNAME	LD	A,#00
	LD	(DE),A
	PUSH	HL
	LD	HL,TMPNAME
	CALL	OPENDIR
	POP	HL
	JP	NC,GETWORD
	RET 

DRVNAME	LD	A,(TMPNAME)
	CP	"a"
	JR	C,DRVN2
	CP	"{"
	JR	NC,DRVN2
	SUB	#20
DRVN2	SUB	"A"
	PUSH	HL
	CALL	OPENDSK
	POP	HL
	JP	NC,GETWORD
	RET 

TMPNAME	DEFB	"	     ",#00

OPENDSK	PUSH	AF
	LD	C,1
	RST	#18
	POP	BC
	JP	C,OPDISK1
	LD	A,B
	LD	(DRIVE),A
	CALL	RD_BPB
	RET	C
	LD	A,(LDRIVE)
	AND	A
	RET 

OPDISK1	CP	2
	SCF 
	RET	Z
	LD	A,20
	SCF 
	RET 

OPENDIR	XOR	A
	CALL	SET_FM
	LD	A,(HL)
	OR	A
	JP	NZ,SUBDIR
	LD	DE,0
	LD	(IY+CLU1),E
	LD	(IY+CLU2),D
	CALL	LOADDIR
	LD	HL,DIRSPEC
	LD	(HL),"\"
	INC	HL
	LD	(HL),#00
	AND	A
	RET 

SUBDIR	CP	"."
	JR	NZ,SUBDIR2
	EXX 
	LD	HL,MASKARE
	LD	DE,MASKARE+1
	LD	BC,10
	LD	(HL),#20
	LDIR 
	EXX 
	LD	DE,MASKARE
SUBDIR0	LDI 
	LD	A,(HL)
	OR	A
	JR	NZ,SUBDIR0
	JR	SUBDIR3

SUBDIR2	LD	DE,MASKARE
	CALL	MASK
	RET	C
SUBDIR3	CALL	FINDDIR
	RET	C
	LD	(IY+CLU1),E
	LD	(IY+CLU2),D
	LD	DE,#4000
	LD	(IY+LEN1),E
	LD	(IY+LEN2),D
	CALL	LOADDIR
	AND	A
	RET 



FINDD03	LD	BC,#0020
	ADD	IX,BC
	JR	NC,FINDD01
FINDD04	POP	AF
	OUT	(PAGE3),A
	LD	A,4
	SCF 
	RET 

; FIND "MASKAREA" IN DIRECTORY

FINDDIR	LD	A,DIRPAGE
	CALL	BANK
	PUSH	AF
	LD	IX,DIR
FINDD01	LD	A,(IX+00)
	OR	A
	JR	Z,FINDD04
	CP	#E5
	JR	Z,FINDD03
	LD	A,(IX+11)
	AND	#10
	JR	Z,FINDD03
	LD	HL,MASKARE
	LD	D,HX
	LD	E,LX
	EX	DE,HL
	LD	B,11
FINDD02	LD	A,(DE)
	CP	"?"
	JR	Z,FINDD05
	CP	(HL)
	JR	NZ,FINDD03
FINDD05	INC	HL
	INC	DE
	DJNZ	FINDD02
	LD	A,(IX+0)
	CP	"."
	JP	NZ,ADDSPEC
	LD	A,(IX+1)
	CP	"."
	JP	NZ,IT_DIR
	LD	HL,DIRSPEC
	LD	D,H
	LD	E,L
	LD	BC,#100
	XOR	A
	CPIR 
	LD	BC,#100
	LD	A,"\"
	CPDR 
	INC	HL
	AND	A
	EX	DE,HL
	SBC	HL,DE
	EX	DE,HL
	JR	NZ,ROTZ
	INC	HL
ROTZ	LD	(HL),0
IT_DIR	LD	E,(IX+CLU1)
	LD	D,(IX+CLU2)
	POP	AF
	OUT	(PAGE3),A
	AND	A
	RET 

ADDSPEC	LD	E,LX
	LD	D,HX
	LD	HL,DIRSPEC
	LD	BC,#FF
	XOR	A
	CPIR 
	DEC	HL
	DEC	HL
	LD	A,"\"
	CP	(HL)
	INC	HL
	JR	Z,ADDSPE0
	LD	(HL),A
	INC	HL
ADDSPE0	LD	BC,#0820
MM1	LD	A,(DE)
	INC	DE
	CP	C
	JR	Z,MM2
	LD	(HL),A
	INC	HL
MM2	DJNZ	MM1
	LD	A,(DE)
	INC	DE
	CP	C
	JR	Z,MM3
	LD	(HL),"."
	INC	HL
	LD	(HL),A
	INC	HL
	LD	A,(DE)
	INC	DE
	CP	C
	JR	Z,MM3
	LD	(HL),A
	INC	HL
	LD	A,(DE)
	CP	C
	JR	Z,MM3
	LD	(HL),A
	INC	HL
MM3	LD	(HL),0
	JP	IT_DIR

CURRDIR	EX	DE,HL
	LD	HL,DIRSPEC
CURDIR1	LD	A,(HL)
	OR	A
	LDI 
	JP	NZ,CURDIR1
	RET 

LOADDIR	XOR	A
	LD	HL,0
	LD	IX,0
	LD	B,0
	CALL	MOVE_FP
	LD	A,DIRPAGE
	CALL	BANK
	PUSH	AF
	LD	HL,#C000
	LD	DE,#C001
	LD	BC,#3FFF
	LD	(HL),L
	LDIR 
	LD	A,(DRIVE)
	LD	(IY+FDRV),A
	LD	D,(IY+CLU1)
	LD	E,(IY+CLU2)
	LD	A,D
	OR	E
	JP	Z,LROTDIR
	LD	HL,DIR
	LD	DE,#4000
	XOR	A
	CALL	READ
	LD	(DIRSIZE),DE
	POP	AF
	OUT	(PAGE3),A
	AND	A
	RET 

LROTDIR	LD	HL,(DIR_FRH)
	LD	IX,(DIR_FRL)
	LD	A,(DIR_S_S)
	LD	B,32
	SUB	B
	JR	NC,RTD1
	ADD	A,B
	LD	B,A
RTD1	LD	A,(DRIVE)
	LD	C,5
	LD	DE,DIR
	RST	#18
	POP	AF
	OUT	(PAGE3),A
	AND	A
	RET 

SAVEDIR	XOR	A
	LD	HL,0
	LD	IX,0
	LD	B,0
	CALL	MOVE_FP
	LD	A,DIRPAGE
	CALL	BANK
	PUSH	AF
	LD	A,(DRIVE)
	LD	(IY+FDRV),A
	LD	D,(IY+CLU1)
	LD	E,(IY+CLU2)
	LD	A,D
	OR	E
	JP	Z,SROTDIR
	LD	HL,DIR
	LD	DE,(DIRSIZE)
	XOR	A
	CALL	WRITE
	POP	AF
	OUT	(PAGE3),A
	AND	A
	RET 

SROTDIR	LD	HL,(DIR_FRH)
	LD	IX,(DIR_FRL)
	LD	A,(DIR_S_S)
	LD	B,32
	SUB	B
	JR	NC,RTD1S
	ADD	A,B
	LD	B,A
RTD1S	LD	A,(DRIVE)
	LD	C,6
	LD	DE,DIR
	RST	#18
	POP	AF
	OUT	(PAGE3),A
	AND	A
	RET 

DIRSIZE	DEFW	0

BANK	LD	C,A
	LD	B,0
	LD	HL,BANKTBL
	ADD	HL,BC
	IN	A,(PAGE3)
	LD	C,PAGE3
	OUTI 
	RET 

BANKTBL	DEFB	#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF
	DEFB	#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF

;G_HAND1 POP	 IX
;	 POP	 HL
;	 POP	 DE
;	 RET

;GHANDLE PUSH	 DE
;	 PUSH	 HL
;	 PUSH	 IX
;	 CALL	 TESTDSK
;	 JP	 C,G_HAND1
;	 CALL	 LOADDIR
;	 POP	 DE
;	 LD	 HL,DIR
;	 LD	 BC,#0020
;G_HAND2 LD	 A,D
;	 OR	 E
;	 JP	 Z,G_HAND3
;	 ADD	 HL,BC
;	 DEC	 DE
;	 JP	 G_HAND2
;G_HAND3 EXX
;	 POP	 DE
;	 EXX
;G_HAND4 EX	 DE,HL
;	 LD	 A,DIRPAGE
;	 CALL	 BANK
;	 EX	 DE,HL
;	 LD	 DE,HANDTA
;	 LDI
;	 LDI
;	 LDI
;	 LDI
;	 LDI
;	 LDI
;	 LDI
;	 LDI
;	 LDI
;	 LDI
;	 LDI
;	 LDI
;	 LDI
;	 LDI
;	 LDI
;	 LDI
;	 LDI
;	 LDI
;	 LDI
;	 LDI
;	 LDI
;	 LDI
;	 LDI
;	 LDI
;	 LDI
;	 LDI
;	 LDI
;	 LDI
;	 LDI
;	 LDI
;	 LDI
;	 LDI
;	 EXX
;	 OUT	 (PAGE3),A
;	 LD	 HL,HANDTA
;	 LDI
;	 LDI
;	 LDI
;	 LDI
;	 LDI
;	 LDI
;	 LDI
;	 LDI
;	 LDI
;	 LDI
;	 LDI
;	 LDI
;	 LDI
;	 LDI
;	 LDI
;	 LDI
;	 LDI
;	 LDI
;	 LDI
;	 LDI
;	 LDI
;	 LDI
;	 LDI
;	 LDI
;	 LDI
;	 LDI
;	 LDI
;	 LDI
;	 LDI
;	 LDI
;	 LDI
;	 LDI
;	 EXX
;	 POP	 BC
;	 DEC	 BC
;	 LD	 A,B
;	 OR	 C
;	 RET	 Z
;	 PUSH	 BC
;	 JP	 G_HAND4

;HANDTA	 DEFB	 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
;	 DEFB	 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

MASKARE
	DEFB	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DEFB	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

; HL - MASK "file*.t??"
; DE - 11 bytes	filename
; RET: C=2 FILE	WITHOUT	EXTENTION
;      C=1 FILE	WITH EXTENTION

MASK	PUSH	HL
	PUSH	DE
	LD	H,D
	LD	L,E
	INC	DE
	LD	(HL),#20
	LD	BC,10
	LDIR 
	POP	DE
	POP	HL
	LD	A,(HL)
	CP	#21
	LD	A,16
	RET	C
	LD	BC,#0902
MASK1	LD	A,(HL)
	CP	#21
	CCF 
	RET	NC
	CP	#22
	JR	Z,MASK7
	CP	"*"
	JR	Z,MASK3
	CP	"+"
	JR	Z,MASK7
	CP	","
	JR	Z,MASK7
	CP	"."
	JR	Z,MASK5
	CP	"/"
	JR	Z,MASK7
	CP	":"
	JR	Z,MASK7
	CP	";"
	JR	Z,MASK7
	CP	"<"
	JR	Z,MASK7
	CP	"="
	JR	Z,MASK7
	CP	">"
	JR	Z,MASK7
	CP	"["
	JR	Z,MASK7
	CP	"\"
	JR	Z,MASK7
	CP	"]"
	JR	Z,MASK7
	CP	"|"
	JR	Z,MASK7
;	CP	"a"
;	JR	C,MASK2
;	CP	"{"
;	JR	NC,MASK2
;	SUB	#20
	CALL	UPPER
MASK2	LD	(DE),A
	INC	HL
	INC	DE
	DJNZ	MASK1
MASK7	LD	A,16
	SCF 
	RET 

MASK3	LD	A,"?"
	INC	HL
	DJNZ	MASK6
	LD	A,16
	SCF 
	RET 

MASK6	LD	(DE),A
	INC	DE
	DJNZ	MASK6
	LD	B,1
	JR	MASK1

MASK5	LD	A," "
	INC	HL
	DJNZ	MASK4
	LD	B,4
	DEC	C
	JP	NZ,MASK1
	LD	A,16
	SCF 
	RET 

MASK4	LD	(DE),A
	INC	DE
	DJNZ	MASK4
	LD	B,4
	DEC	C
	JP	NZ,MASK1
	LD	A,16
	SCF 
	RET 

UPPER	CP	"a"
	RET	C
	CP	"{"
	JR	NC,MDUPPER
	SUB	#20
NOUPPER	RET 

MDUPPER	CP	#A0
	JR	C,NOUPPER
	CP	#B0
	JR	NC,BGUPPER
	SUB	#20
	RET 

BGUPPER	CP	#E0
	JR	C,NOUPPER
	CP	#F0
	JR	NC,HGUPPER
	SUB	#50
	RET 

HGUPPER	CP	#F1
	RET	NZ
	DEC	A
	RET 

SYSTIME	LD	C,#F5
	RST	#08
	JP	C,NOCMOS
	LD	D,7	;DAY
	CALL	RCMOS
	PUSH	AF
	LD	D,8	;MONTH
	CALL	RCMOS
	POP	DE
	LD	E,A
	PUSH	DE
	LD	D,4	;HOUR
	CALL	RCMOS
	PUSH	AF
	LD	D,2	;MINUTE
	CALL	RCMOS
	POP	DE
	LD	E,A
	PUSH	DE
	LD	D,0	;SECOND
	CALL	RCMOS
	PUSH	AF
	LD	D,6	;WEEK DAY
	LD	C,#F6
	RST	#08
	POP	DE
	LD	E,A
	PUSH	DE
	LD	D,9	;YEAR
	CALL	RCMOS	;READ AND CONVERT TO DECIMAL
	PUSH	AF
	LD	D,#32	;CENTURY
	LD	C,#F6
	RST	#08
	LD	HX,A

	POP	AF
	CP	80	;R01, TEST DECIMAL FIX
	PUSH	AF
	JR	C,XXIAGE
	LD	A,#19
	CP	HX
	JR	Z,GOODAGE
	JR	BADAGE

XXIAGE	LD	A,#20
	CP	HX
	JR	Z,GOODAGE
BADAGE	PUSH	AF
	LD	D,#32	;CENTURY
	LD	C,#F7
	RST	#08
	POP	AF
	LD	HX,A
GOODAGE	POP	AF
	LD	LX,A
	LD	A,HX
	CALL	BCD2HEX
	LD	L,A
	LD	H,0
	LD	C,L
	LD	B,H
	LD	HX,B
	ADD	HL,HL
	ADD	HL,HL
	ADD	HL,BC
	ADD	HL,HL	;*10
	LD	B,H
	LD	C,L
	ADD	HL,HL
	ADD	HL,HL
	ADD	HL,BC
	ADD	HL,HL	;*10(100)
	EX	DE,HL
	ADD	IX,DE
	POP	BC
	POP	HL
	POP	DE
	AND	A
	RET 

RCMOS	LD	C,#F6
	RST	#08
; INPUT	: A - BCD
; OUTPUT: A - HEX
BCD2HEX
	LD	E,A
	RRCA 
	RRCA 
	RRCA 
	RRCA 
	AND	#0F
	LD	D,A
	ADD	A,A
	ADD	A,A
	ADD	A,D
	ADD	A,A
	LD	D,A
	LD	A,E
	AND	#0F
	ADD	A,D
	RET 

NOCMOS	LD	DE,(NC_DAY)  ;DAY/MONTH
	LD	HL,(NC_HOUR) ;HOUR/MINUTE
	LD	BC,(NC_SEC)  ;SECOND/WEEKDAY
	LD	IX,(NC_YEAR) ;YEAR
	AND	A
	RET 

NOCMOS2	LD	C,0
	LD	(NC_DAY),DE  ;DAY/MONTH
	LD	(NC_HOUR),HL ;HOUR/MINUTE
	LD	(NC_SEC),BC  ;SECOND/WEEKDAY
	LD	(NC_YEAR),IX ;YEAR
	AND	A
	RET 

SETTIME	PUSH	IX
	PUSH	BC
	PUSH	HL
	PUSH	DE
	LD	C,#F5
	RST	#08
	JP	C,NOCMOS2
	POP	AF
	PUSH	AF
	LD	D,7	;DAY
	CALL	WCMOS
	POP	BC
	LD	A,C
	LD	D,8	;MONTH
	CALL	WCMOS
	POP	AF
	PUSH	AF
	LD	D,4	;HOUR
	CALL	WCMOS
	POP	BC
	LD	A,C
	LD	D,2	;MINUTE
	CALL	WCMOS
	POP	AF
	PUSH	AF
	LD	D,0	;SECOND
	CALL	WCMOS
	POP	BC
	LD	A,C
	LD	D,6	;WEEK DAY
	LD	C,#F7
	RST	#08

	POP	HL
	XOR	A
	LD	DE,100
YR	INC	A
	SBC	HL,DE
	JR	NC,YR
	ADD	HL,DE
	DEC	A
	PUSH	HL
	LD	D,#32	;CENTURY
	CALL	WCMOS
	POP	BC
	LD	A,C
	LD	D,9	;YEAR
	CALL	WCMOS
	AND	A
	RET 


WCMOS	CALL	HEX2BCD
	LD	C,#F7
	RST	#08
	RET 

; INPUT	: A - HEX
; OUTPUT: A - BCD
HEX2BCD
	LD	BC,#0AFF
H2B	INC	C
	SUB	B
	JR	NC,H2B
	ADD	A,B
	LD	B,A
	LD	A,C
	RLCA 
	RLCA 
	RLCA 
	RLCA 
	AND	#F0
	OR	B
	RET 

NC_DAY	DEFW	DAY*256+MONTH ;DAY/MONTH
NC_HOUR	DEFW	#0000	      ;HOUR/MINUTE
NC_SEC	DEFW	#0001	      ;SECOND/WEEKDAY
NC_YEAR	DEFW	YEAR	      ;YEAR


GET_D_T
	CALL	SET_FM
	RET	C
	LD	E,(IY+TIM1)
	LD	D,(IY+TIM2)
	LD	C,(IY+DAT1)
	LD	B,(IY+DAT2)
	CALL	RMKTIME
	AND	A
	RET 

PUT_D_T	PUSH	AF
	CALL	MK_TIME
	POP	AF
	PUSH	DE
	PUSH	BC
	CALL	SET_FM
	POP	BC
	POP	DE
	RET	C
	LD	(IY+TIM1),E
	LD	(IY+TIM2),D
	LD	(IY+DAT1),C
	LD	(IY+DAT2),B
	AND	A
	RET 

;INPUT:	D - DAY;  E - MONTH
;	H - HOUR; L - MINUTE
;	B - SECOND (0...59)
;	IX- YEAR (0...65535)
;OUTPUT: DE - hhhhhmmmmmmsssss	h - hour, m - min, s - sec/2
;	 BC - yyyyyyymmmmddddd	y - year, m - month, d - day
;			       (1980-2108)

MK_TIME	LD	A,L
	RLCA 
	RLCA 
	SLA	A
	RL	H
	SLA	A
	RL	H
	SLA	A
	RL	H
	SRL	B
	OR	B
	LD	L,A

	LD	BC,#F844	;(-1980)
	ADD	IX,BC
	LD	A,E
	RLCA 
	RLCA 
	RLCA 
	RLCA 
	AND	#F0
	LD	B,LX
	SLA	A
	RL	B
	OR	D
	LD	C,A
	EX	DE,HL
	AND	A
	RET 

;INPUT:	DE - hhhhhmmmmmmsssss  h - hour, m - min, s - sec/2
;	BC - yyyyyyymmmmddddd  y - year, m - month, d -	day
;			       (1980-2108)
;OUTPUT: D - DAY;  E - MONTH
;	 H - HOUR; L - MINUTE
;	 B - SECOND (0...59)
;	 IX- YEAR (0...65535)

RMKTIME	EX	DE,HL
	LD	A,C
	AND	#1F
	LD	D,A
	SRL	B
	RR	C
	LD	A,C
	RRCA 
	RRCA 
	RRCA 
	RRCA 
	AND	#0F
	LD	E,A
	LD	C,B
	LD	B,0
	LD	IX,1980
	ADD	IX,BC
	LD	A,L
	AND	#1F
	ADD	A,A
	LD	B,A
	SRL	H
	RR	L
	SRL	H
	RR	L
	SRL	H
	RR	L
	SRL	L
	SRL	L
	AND	A
	RET 

;  INPUT: HL - "C:\DIR\DIR\DIR_NAME[\]",0

CHDIR	CALL	GETWORD
	RET	C
	LD	HL,TMPNAME
	LD	A,(HL)
	OR	A
	CALL	NZ,OPENDIR
	RET 



;  INPUT: HL - "C:\DIR\DIR\DIR_NAME",0

MKDIR	CALL	GETWORD
	RET	C
	LD	HL,TMPNAME
	LD	DE,MASKARE
	CALL	MASK
	RET	C
	CALL	LOADDIR
	CALL	DSEARCH
	LD	A,15
	CCF 
	RET	C
	CALL	G_CLUST
	RET	C
	PUSH	HL
	LD	DE,(ENDCLUS)
	CALL	W_T_FAT
	CALL	WR_FAT
	LD	HL,MASKARE
	LD	DE,HANDBUF
	LD	BC,11
	LDIR 
	EX	DE,HL
	LD	A,#10
	LD	(HL),A
	INC	HL
	LD	BC,#0A00
FIHND0	LD	(HL),C
	INC	HL
	DJNZ	FIHND0
	PUSH	HL
	CALL	SYSTIME
	CALL	MK_TIME
	POP	HL
	LD	(HL),E
	INC	HL
	LD	(HL),D
	INC	HL
	LD	(HL),C
	INC	HL
	LD	(HL),B
	INC	HL
	POP	DE
	PUSH	DE
	LD	(HL),E
	INC	HL
	LD	(HL),D
	INC	HL
	LD	BC,#0400
FIHND2	LD	(HL),C
	INC	HL
	DJNZ	FIHND2
	CALL	WRT_HND
	CALL	SAVEDIR
	LD	HL,SECBUF
	LD	(HL),"."
	LD	B,10
MKD02	INC	HL
	LD	A,#20
	LD	(HL),A
	DJNZ	MKD02
	INC	HL
	LD	DE,HANDBUF+11
	EX	DE,HL
	LD	BC,21
	LDIR 
	EX	DE,HL
	LD	(HL),"."
	INC	HL
	LD	(HL),"."
	LD	B,9
MKD03	INC	HL
	LD	A,#20
	LD	(HL),A
	DJNZ	MKD03
	INC	HL
	PUSH	HL
	LD	A,DIRPAGE
	CALL	BANK
	POP	HL
	PUSH	AF
	LD	A,(DIR)
	CP	"."
	LD	DE,DIR+11
	JP	Z,MKD04
	LD	IX,HANDBUF
	XOR	A
	LD	(IX+CLU1),A
	LD	(IX+CLU2),A
	LD	DE,HANDBUF+11
MKD04	EX	DE,HL
	LD	BC,21
	LDIR 
	POP	AF
	OUT	(PAGE3),A
	EX	DE,HL
	LD	D,H
	LD	E,L
	INC	DE
	LD	(HL),0
	LD	BC,512-65
	LDIR 
	POP	HL
	CALL	NSECTOR
	LD	A,(S_P_C)
MKD12	PUSH	AF
	PUSH	HL
	PUSH	IX
	IN	A,(PAGE3)
	PUSH	AF
	IN	A,(PAGE0)
	OUT	(PAGE3),A
;
	LD	DE,SECBUF+#C000
	LD	B,1
	LD	A,(DRIVE)
	LD	C,6
	RST	#18
;
	POP	AF
	OUT	(PAGE3),A

	LD	HL,SECBUF
	LD	DE,SECBUF+1
	LD	BC,511
	LD	(HL),0
	LDIR 
	POP	IX
	POP	HL
	INC	IX
	LD	A,HX
	OR	LX
	JR	NZ,MKD11
	INC	HL
MKD11	POP	AF
	DEC	A
	JR	NZ,MKD12
	AND	A
	RET 

;  INPUT: HL - "C:\DIR\DIR\DIR_NAME",0

RMDIR	CALL	GETWORD
	RET	C
	LD	HL,TMPNAME
	LD	DE,MASKARE
	CALL	MASK
	RET	C
	LD	HL,MASKARE
	LD	BC,11
	LD	A,"?"
	CPIR 
	LD	A,16
	SCF 
	RET	Z
	CALL	LOADDIR
	CALL	DSEARCH
	RET	C
	LD	HL,(HANDBUF+CLU1)
	PUSH	IX
RMD17	PUSH	HL
	CALL	NSECTOR
	LD	A,(S_P_C)
RMD12	PUSH	AF
	PUSH	HL
	PUSH	IX
	IN	A,(PAGE3)
	PUSH	AF
	IN	A,(PAGE0)
	OUT	(PAGE3),A

	LD	DE,SECBUF+#C000
	LD	BC,#0105
	LD	A,(DRIVE)
	RST	#18

	POP	AF
	OUT	(PAGE3),A

	LD	B,16
	LD	HL,SECBUF
RMD10	LD	A,(HL)
	OR	A
	JP	Z,RMD15	 ;DIR EMPTY
	CP	"."
	JR	Z,RMD14
	CP	#E5
	JR	Z,RMD14
	LD	DE,11
	ADD	HL,DE
	LD	A,(HL)
	SBC	HL,DE
	BIT	3,A
	JP	Z,RMD16	;DIR NOT EMPTY
RMD14	LD	DE,#0020
	ADD	HL,DE
	DJNZ	RMD10
	POP	IX
	POP	HL
	INC	IX
	LD	A,HX
	OR	LX
	JR	NZ,RMD11
	INC	HL
RMD11	POP	AF
	DEC	A
	JR	NZ,RMD12
	POP	HL
	CALL	R_F_FAT
	EX	DE,HL
	JR	NC,RMD17
RMD18	POP	IX
	JP	DELFILE

RMD15	POP	IX
	POP	HL
	POP	AF
	POP	HL
	JR	RMD18

RMD16	POP	IX
	POP	HL
	POP	AF
	POP	HL
	POP	IX
	LD	A,11
	SCF 
	RET 

;//MODULE: DOS5
;[END]



