
; System installator SYS.EXE
; Created 18.08.2000
;

	ORG	#8100-512
INCLUDE	"DOS_EQU
	DEFB	"EXE"	;EXE ID
	DEFB	#00	;EXE VERSION
	DEFW	#0200	;CODE OFFSET LOW
	DEFW	#0000	;CODE OFFSET HIGH
	DEFW	#0000	;END-BEG ;PRIMARY LOADER
	DEFW	#0000	;
	DEFW	#0000	;RESERVED
	DEFW	#0000	;
	DEFW	#8100	;LOAD ADDRESS
	DEFW	#8100	;START ADDRESS
	DEFW	#BFFF	;STACK ADDRESS
	DEFS	490,0
BEG	PUSH	IX
	LD	HL,MSG0
	LD	C,PCHARS
	RST	#10
	POP	HL
	CALL	GETKEY
	JP	C,NOPARAM
	LD	A,B
	LD	(DEST_D),A
	LD	C,CURDISK
	RST	#10
	LD	(SOUR_D),A
	LD	HL,MSG2
	LD	C,PCHARS
	RST	#10
	CALL	INSTALL
	JP	C,IERROR
	LD	HL,MSG1
	LD	C,PCHARS
	RST	#10
	LD	A,(DEST_D)
	LD	B,"A"
	ADD	A,B
	LD	C,PUTCHAR
	RST	#10
	LD	A,":"
	LD	C,PUTCHAR
	RST	#10
	LD	A,13
	LD	C,PUTCHAR
	RST	#10
	LD	A,10
	LD	C,PUTCHAR
	RST	#10
	XOR	A
QUITT	LD	C,#41
	RST	#10
	JR	$

NOPARAM
	LD	HL,MSG3
	LD	C,PCHARS
	RST	#10
	LD	A,1
	JP	QUITT

IERROR
	LD	HL,MSG4
	LD	C,PCHARS
	RST	#10
	LD	A,255
	JP	QUITT

INSTALL	LD	A,(DEST_D)
	LD	HL,0
	LD	IX,0
	LD	DE,BUFFER
	LD	BC,#0105
	RST	#18
	RET	C
	LD	A,(BUFFER+#15)
	CP	#F0
	RET	C
	CP	#F8
	JP	Z,IT_HDD
	CP	#F0
	JP	Z,IT_FDD
	CP	#F9
	JP	Z,IT_FDD
	SCF 
	RET 

IT_FDD
	LD	A,(BUFFER+#10)	;FATS
	DEC	A		;DEC FAT COPIES
	LD	(BUFFER+#10),A	;NEW FATS
	LD	HL,(BUFFER+#0E)	;RESERVED
	LD	BC,(BUFFER+#16)	;SECTOR	PER FAT
	LD	A,B
	OR	C
	SCF 
	RET	Z
	ADD	HL,BC
	LD	(BUFFER+#0E),HL	;NEW RESERVED
	LD	A,(DEST_D)
	LD	HL,0
	LD	IX,0
	LD	DE,BUFFER
	LD	BC,#0106
	RST	#18
	RET	C
	LD	A,(DEST_D)
	LD	HL,0
	LD	IX,1
	LD	DE,LOADER
	LD	BC,#0306
	RST	#18
	RET 

IT_HDD
	LD	A,(DEST_D)
	SUB	2
	LD	A,#80
	JR	Z,TOSLAVE
	LD	A,#81
TOSLAVE	LD	HL,0
	LD	IX,1
	LD	DE,LOADER
	LD	BC,#0356
	RST	#08
	RET 

GETKEY	INC	HL
	LD	DE,BUFFER
	LD	C,GSWITCH
	RST	#10
	LD	DE,BUFFER
	LD	A,(DE)
	INC	DE
	LD	B,A
	LD	A,(DE)
	INC	DE
	CP	":"
	JR	NZ,BD001
	LD	A,(DE)
	INC	DE
	OR	A
	JR	NZ,BD001
	LD	A,B
	CP	"A"
	JR	C,BD001
	CP	"z"+1
	JR	NC,BD001
	RES	5,A
	SUB	"A"
	LD	B,A
	XOR	A
	RET 
BD001	SCF 
	RET 

LOADER	INCBIN "  PRIBOOT3

SOUR_D	DEFB	0
DEST_D	DEFB	0

MSG0	DEFB	"Boot install v0.01",13,10,13,10,0
MSG1	DEFB	"System	installed on disk ",0
MSG2	DEFB	"Installing boot loader...",13,10,0

MSG3	DEFB	"Invalid drive letter",13,10,0
MSG4	DEFB	"Can't install boot on this drive",13,10,0

BUFFER	DEFB	0,0,0,0,0,0

END



